/////////////////////////////////////////////////////////////////////////////
// $Id:$
//////////////////////////////////////////////////////////////////////////////
//                                  Stella
//                        "An Atari 2600 Simulator"
//                         Copyright (c) 1995,1996
//                            Bradford W. Mott
//////////////////////////////////////////////////////////////////////////////
//
// SoundOS2
//
//   This class implements the sound API for the OS/2 operating system.
//
// October 4,1996
//
//////////////////////////////////////////////////////////////////////////////
// $Log:$
//////////////////////////////////////////////////////////////////////////////

#ifndef SOUNDOS2_HXX
#define SOUNDOS2_HXX

#include "bspf.hxx"
#include "sound.hxx"
#include "tiasound.h"

int audio_init (void);
void audio_play (void);
void audio_close (void);

class SoundOS2 : public Sound
{
  public:
    // Constructor
    SoundOS2();

    // Destructor
    virtual ~SoundOS2();

  public:
    // Set the given sound register to the specified value
    virtual void set(Sound::Register reg, uInt8  value);
    virtual void mute(bool state);
  private:
    // Indicates if the sound system couldn't be initialized
    bool myDisabled;

    // Indicates if the sound is muted or not
    bool myMute;

    // Process Id of the stella-sound process
    int myProcessId;

    // Write file descriptor for IPC
    int myFd;

    // Buffers for the audio registers used so we only
    // send "changes" to the stella-sound process
    uInt8  myAUDC0;
    uInt8  myAUDC1;
    uInt8  myAUDF0;
    uInt8  myAUDF1;
    uInt8  myAUDV0;
    uInt8  myAUDV1;
};
#endif

