// $Id:$
//////////////////////////////////////////////////////////////////////////////
//                                Stella 96
//                        "An Atari 2600 Simulator"
//                         Copyright (c) 1995,1996
//                            Bradford W. Mott
//////////////////////////////////////////////////////////////////////////////
//
// Terminal
//
//   This class provides a standard API for the screen.  This file contains
// the OS/2 Presentation Manager implementation of the API.
//
// Darrell Spice Jr.
// August 30, 1996
//
//////////////////////////////////////////////////////////////////////////////
// $Log:$
//////////////////////////////////////////////////////////////////////////////

#include <assert.h>
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

#include "termos2.hxx"
#include "os2res.hxx"
#include "TIA.hxx"
#include "SndOS2.hxx"
#include "bspf.hxx"
#include "tiasound.h"
#include "Event.hxx"
#include "Console.hxx"

#include "dialog.h"

#define INCL_WIN
#define INCL_GPI
#define INCL_DOS
#define INCL_DOSPROCESS
#include <os2.h>

// DIVE required header files
#define  _MEERROR_H_
#include <mmioos2.h>
#include <dive.h>
#include <fourcc.h>
#include "sndos2.hxx"

// Dive variables
DIVE_CAPS          DiveCaps           = {0};
FOURCC             fccFormats[100]    = {0};
HDIVE              hDive              = NULLHANDLE;
BOOL               bDiveHaveBuffer    = FALSE;
ULONG              ulDiveBufferNumber = 0;
HDC                hdcClientHDC = NULLHANDLE;
HPAL               hpalMain;

BOOL StealMouse = FALSE;
Int32 MouseReading;

//----------------------------------------------------
// INI file setting variables
int maxskip;
int minskip;
int initskip;
int windowsize;
int oscilloscope;
extern int buflen;
extern ULONG AUDIOfreq;
int UseCartHeight;
char scJoystickZeroLeft;
char scJoystickZeroRight;
char scJoystickZeroUp;
char scJoystickZeroDown;
char scJoystickZeroFire;
char scBoosterGripZeroTrigger;
char scJoystickOneLeft;
char scJoystickOneRight;
char scJoystickOneUp;
char scJoystickOneDown;
char scJoystickOneFire;
char scBoosterGripOneTrigger;
char scQuit;
char scSelect;
char scReset;
char scColor;
char scBnW;
char sc1A;
char sc1B;
char sc2A;
char sc2B;
char scKeyboardZero1;
char scKeyboardZero2;
char scKeyboardZero3;
char scKeyboardZero4;
char scKeyboardZero5;
char scKeyboardZero6;
char scKeyboardZero7;
char scKeyboardZero8;
char scKeyboardZero9;
char scKeyboardZeroStar;
char scKeyboardZero0;
char scKeyboardZeroPound;
char scKeyboardOne1;
char scKeyboardOne2;
char scKeyboardOne3;
char scKeyboardOne4;
char scKeyboardOne5;
char scKeyboardOne6;
char scKeyboardOne7;
char scKeyboardOne8;
char scKeyboardOne9;
char scKeyboardOneStar;
char scKeyboardOne0;
char scKeyboardOnePound;
char scNewGame;
char scPause;
BOOL ShowCartNote;
int paddle[4];
// End of INI file setting variables
//----------------------------------------------------


// dialog box variables
int db_volume, db_frequency, db_buffer, db_osc; // audio
int db_frt, db_min, db_max, db_init, db_size, db_height, db_note; // video
int db_paddle0, db_paddle1, db_paddle2, db_paddle3; // paddles
int db_OK; // TRUE if dialog box not cancelled


// from Marty - trap ALT key for emulator's use
PFNWP OldFrameWinProc;
MRESULT EXPENTRY FrameWinKeyBypass( HWND win, ULONG message,
  MPARAM mp1, MPARAM mp2 ) {
    if (message == WM_CHAR) { return 0; }
    // Don't pass the keystroke to the PM if the emulator is running
    if (message == WM_TRANSLATEACCEL) { return 0; }
    // Don't allow TRANSLATEACCEL messages if the emulator is running.
    return (*OldFrameWinProc) (win, message, mp1, mp2 );
}

MRESULT EXPENTRY ClientWndProc (HWND, ULONG, MPARAM, MPARAM) ;
MRESULT EXPENTRY DlgProc(HWND hwndWnd, ULONG ulMsg, MPARAM mpParm1, MPARAM mpParm2);

// Menu Variables
// current bitmaps handles
HBITMAP hbmctvc, hbmctvb, hbmcp1la, hbmcp1lb, hbmcp2la, hbmcp2lb;
HBITMAP hbmcng, hbmcslct, hbmcrst, hbmcset;
HBITMAP hbmccrt, hbmchlp;
// small bitmap handles
HBITMAP hbmstvc, hbmstvb, hbmsp1la, hbmsp1lb, hbmsp2la, hbmsp2lb;
HBITMAP hbmsng, hbmsslct, hbmsrst, hbmsset;
HBITMAP hbmscrt, hbmshlp;
// medium bitmap handles
HBITMAP hbmmtvc, hbmmtvb, hbmmp1la, hbmmp1lb, hbmmp2la, hbmmp2lb;
HBITMAP hbmmng, hbmmslct, hbmmrst, hbmmset;
HBITMAP hbmmcrt, hbmmhlp;

HBITMAP hbjoystick, hbbooster, hbkeyboard, hbpaddles, hblightgun, hbmindlink, hbdriving;
HBITMAP hbleft, hbright;



MENUITEM miItem;
HWND hwndMenu;
int resetmenukey, resetmenukey1, resetmenukey2, resetmenukey3, resetmenukey4, resetmenukey5;
int resetmenukey6, resetmenukey7, resetmenukey8, resetmenukey9, resetmenukey10, resetmenukey11;
int resetmenukey12, resetmenukey13, resetmenukey14, resetmenukey15;
CHAR carthelppath[CCHMAXPATH] = "";
CHAR carthelpfile[CCHMAXPATH] = "";
CHAR carthelpfullfile[CCHMAXPATH] = "";
CHAR dragfilename[CCHMAXPATH] = "nada";
extern char* StellaHelp;
extern char* StellaIni;

extern Event theEvent;
extern bool theQuitIndicator;
extern Console* theConsole;



// PM Window variables
HAB          hab ;
HMQ          hmq ;
HWND         hwndFrame, hwndClient ;
QMSG         qmsg ;

// PM Bitmap variables
HPS                hps, hpsClient ;
RECTL              rcl ;
BITMAPINFOHEADER2  bmp;

FONTMETRICS fm;
RECTL       udrcl;

// Indicates the width and height based on the property information
uInt32 theWidth = 160;
uInt32 theHeight = 210;
uInt32 theXStart;
int infoheight;

int scrHEIGHT;
#define Black 0
#define Green 172
int ViewWave;
Int8 *ViewWaveStart;
Int8 *XBuf;

// Indicates if the entire frame should be redrawn
bool theRedrawEntireFrameFlag = true;

uInt8* currentframe ;

int frt = 0;               /* frame rate table.  0 = 60 fps, 1 = 50 fps */
double framerate, newrate;

DATETIME now, last;

CHAR wintext[100];

int width, height;

int game_paused;
int stella_active;
int throttle;

BOOL Control = FALSE;

// screen update info
int newcount = 10;
int titlecount = 0;

ULONG Palette2[256];

POINTL ptl, aptl[4];
BITMAPINFO2 * pbmi;
CHAR szTitle[2048];

extern int newgame;
extern int firstgame;
extern unsigned char* curplaybuf;
extern int AudioOK;

int screenx, screeny, xborderwidth, yborderwidth, titleheight, menubarheight;
int midscreenx, midscreeny;
int skip, framecount;

ERRORID err;
CHAR  szClientClass[20] ;

// Joystick Support Variables
#include "joyos2.h"


Event keyboardEvent;

string CartridgeNote;

int DiveMap(uInt8 *buffer)
{
    ulDiveBufferNumber = 0;
    bDiveHaveBuffer = FALSE;
    // Associate the canvas with a DIVE handle
    if (DiveAllocImageBuffer (hDive, &ulDiveBufferNumber, FOURCC_LUT8,
                          160, 300, 160,  (PBYTE) buffer) != NULL)
      {
      // post error message here.
      //PostError (hab, hwndFrame, IDS_ERR_CREATE_DIVEBUFFER);
       return (FALSE);
        };
      bDiveHaveBuffer = TRUE;

          // Turn on visible region notification.
         WinSetVisibleRegionNotify (hwndClient, TRUE);

           // Send an invalidation message to the client.
          WinPostMsg (hwndFrame, WM_VRNENABLED, 0L, 0L );
     XBuf = (Int8 *) buffer;
     ViewWaveStart = XBuf + 160 * scrHEIGHT;

    return (TRUE);
}

int DiveUnMap(void)
{
  if (bDiveHaveBuffer)
    {
    DiveFreeImageBuffer (hDive, ulDiveBufferNumber);
    ulDiveBufferNumber = 0;
    bDiveHaveBuffer = FALSE;
    };
  return TRUE;
}

// set up DIVE - if not possible, display message and quit program
int InitializeDive()
{
    // Get the screen capabilities, and if the system supports only 16 colors
    //  the program should be terminated.

    DiveCaps.pFormatData    = fccFormats;
    DiveCaps.ulFormatLength = 100;
    DiveCaps.ulStructLen    = sizeof(DIVE_CAPS);

    if ( DiveQueryCaps ( &DiveCaps, DIVE_BUFFER_SCREEN ))
       {
       WinMessageBox( HWND_DESKTOP, HWND_DESKTOP,
           (PSZ)"Error: DIVE routines cannot function in this system environment.",
           (PSZ)"   This program is unable to run.", 0, MB_OK | MB_INFORMATION );
       return (FALSE);
       };

    if ( DiveCaps.ulDepth < 8 )
       {
       WinMessageBox( HWND_DESKTOP, HWND_DESKTOP,
           (PSZ)"Error: Not enough screen colors to run DIVE.  Must be at least 256 colors.",
           (PSZ)"   This program is unable to run.", 0, MB_OK | MB_INFORMATION );
       return (FALSE);
       };

    // Get an instance of DIVE APIs.
    if ( DiveOpen ( &hDive, FALSE, 0 ) )
       {
       WinMessageBox( HWND_DESKTOP, HWND_DESKTOP,
           (PSZ)"Error: Unable to open an instance of DIVE.",
           (PSZ)"   This program is unable to run.", 0, MB_OK | MB_INFORMATION );
       return (FALSE);
       };

    return (TRUE);
};


VOID SizeTheWindow(HWND hwnd, int size)
{
   static int width, height;
   static int lastsize = 1;
   if (size > 0)
      lastsize = size;

   width = 320 * lastsize;
   height = (scrHEIGHT + ViewWave) * lastsize;

   if (lastsize > 1)
      menubarheight = 52;
   else
      menubarheight = 34;

   WinSetWindowPos(hwndFrame, NULLHANDLE,
                     (screenx - width - 2*xborderwidth)/2,
                     (screeny - height - 2*yborderwidth - titleheight - menubarheight)/2,
                     width + 2*xborderwidth, height + 2*yborderwidth + titleheight + menubarheight + infoheight,
                     SWP_SIZE|SWP_MOVE|SWP_ACTIVATE|SWP_SHOW);

   // force update of window title display
   titlecount = framecount = newcount = 0;
}




// create window
int OpenWindow()
{
   HINI hini;
   ULONG cb;
   int i;

   // initialize w/grayscale palette - it'll be changed when game is loaded
   for (i = 0;i < 256;i++)
      Palette2[i] = PC_RESERVED * 16777216 + i<<16 + i<<8 + i;

   strcpy(szClientClass, "StellaWindow");

   stella_active = FALSE;
   skip = 0;
   framecount = 0;
   throttle = 0;

   scrHEIGHT = 210;

   hab = WinInitialize (0) ;
   hmq = WinCreateMsgQueue (hab, 0) ;


   hini = PrfOpenProfile(hab, StellaIni); // load saved settings
   if (hini)
   {
      PrfQueryProfileSize(hini, "stella", "maxskip", &cb);
      if (cb == sizeof(maxskip))
      {
         if (!PrfQueryProfileData(hini,"stella","maxskip", &maxskip, &cb))
            maxskip = 15; // default
      }
      else
         maxskip = 15;

      PrfQueryProfileSize(hini, "stella", "minskip", &cb);
      if (cb == sizeof(minskip))
      {
         if (!PrfQueryProfileData(hini,"stella","minskip", &minskip, &cb))
            minskip = 0; // default
      }
      else
         minskip = 0;

      PrfQueryProfileSize(hini, "stella", "initskip", &cb);
      if (cb == sizeof(initskip))
      {
         if (!PrfQueryProfileData(hini,"stella","initskip", &initskip, &cb))
            initskip = 0; // default
      }
      else
         initskip = 0;

      PrfQueryProfileSize(hini, "stella", "windowsize", &cb);
      if (cb == sizeof(windowsize))
      {
         if (!PrfQueryProfileData(hini,"stella","windowsize", &windowsize, &cb))
            windowsize = 1; // default
      }
      else
         windowsize = 1;

      PrfQueryProfileSize(hini, "stella", "oscilloscope", &cb);
      if (cb == sizeof(oscilloscope))
      {
         if (!PrfQueryProfileData(hini,"stella","oscilloscope", &oscilloscope, &cb))
            oscilloscope = 0; // default
      }
      else
         oscilloscope = 0;

      PrfQueryProfileSize(hini, "stella", "buflen", &cb);
      if (cb == sizeof(buflen))
      {
         if (!PrfQueryProfileData(hini,"stella","buflen", &buflen, &cb))
            buflen = 1024; // default
      }
      else
         buflen = 1024;

      PrfQueryProfileSize(hini, "stella", "AUDIOfreq", &cb);
      if (cb == sizeof(AUDIOfreq))
      {
         if (!PrfQueryProfileData(hini,"stella","AUDIOfreq", &AUDIOfreq, &cb))
            AUDIOfreq = 31400; // default
      }
      else
         AUDIOfreq = 31400;

      PrfQueryProfileSize(hini, "stella", "AudioON", &cb);
      if (cb == sizeof(AudioOK))
      {
         if (!PrfQueryProfileData(hini,"stella","AudioON", &AudioOK, &cb))
            AudioOK = TRUE; // default
      }
      else
         AudioOK = TRUE;


      PrfQueryProfileSize(hini, "stella", "UseCartHeight", &cb);
      if (cb == sizeof(UseCartHeight))
         {
         if (!PrfQueryProfileData(hini,"stella", "UseCartHeight", &UseCartHeight, &cb))
            UseCartHeight = TRUE; // default
         }
      else
         UseCartHeight = TRUE;

      PrfQueryProfileSize(hini, "keyboard", "JoystickZeroLeft", &cb);
      if (cb == sizeof(scJoystickZeroLeft))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickZeroLeft", &scJoystickZeroLeft, &cb))
            scJoystickZeroLeft = 0x63; // default
         }
      else
         scJoystickZeroLeft = 0x63;

      PrfQueryProfileSize(hini, "keyboard", "JoystickZeroRight", &cb);
      if (cb == sizeof(scJoystickZeroRight))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickZeroRight", &scJoystickZeroRight, &cb))
            scJoystickZeroRight = 0x64; // default
         }
      else
         scJoystickZeroRight = 0x64;

      PrfQueryProfileSize(hini, "keyboard", "JoystickZeroUp", &cb);
      if (cb == sizeof(scJoystickZeroUp))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickZeroUp", &scJoystickZeroUp, &cb))
            scJoystickZeroUp = 0x61; // default
         }
      else
         scJoystickZeroUp = 0x61;

      PrfQueryProfileSize(hini, "keyboard", "JoystickZeroDown", &cb);
      if (cb == sizeof(scJoystickZeroDown))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickZeroDown", &scJoystickZeroDown, &cb))
            scJoystickZeroDown = 0x66; // default
         }
      else
         scJoystickZeroDown = 0x66;

      PrfQueryProfileSize(hini, "keyboard", "JoystickZeroFire", &cb);
      if (cb == sizeof(scJoystickZeroFire))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickZeroFire", &scJoystickZeroFire, &cb))
            scJoystickZeroFire = 0x5e; // default
         }
      else
         scJoystickZeroFire = 0x5e;

      PrfQueryProfileSize(hini, "keyboard", "BoosterGripZeroTrigger", &cb);
      if (cb == sizeof(scBoosterGripZeroTrigger))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "BoosterGripZeroTrigger", &scBoosterGripZeroTrigger, &cb))
            scBoosterGripZeroTrigger = 0x5b; // default
         }
      else
         scBoosterGripZeroTrigger = 0x5b;

      PrfQueryProfileSize(hini, "keyboard", "JoystickOneLeft", &cb);
      if (cb == sizeof(scJoystickOneLeft))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickOneLeft", &scJoystickOneLeft, &cb))
            scJoystickOneLeft = 0x2e; // default
         }
      else
         scJoystickOneLeft = 0x2e;

      PrfQueryProfileSize(hini, "keyboard", "JoystickOneRight", &cb);
      if (cb == sizeof(scJoystickOneRight))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickOneRight", &scJoystickOneRight, &cb))
            scJoystickOneRight = 0x30; // default
         }
      else
         scJoystickOneRight = 0x30;

      PrfQueryProfileSize(hini, "keyboard", "JoystickOneUp", &cb);
      if (cb == sizeof(scJoystickOneUp))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickOneUp", &scJoystickOneUp, &cb))
            scJoystickOneUp = 0x21; // default
         }
      else
         scJoystickOneUp = 0x21;

      PrfQueryProfileSize(hini, "keyboard", "JoystickOneDown", &cb);
      if (cb == sizeof(scJoystickOneDown))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickOneDown", &scJoystickOneDown, &cb))
            scJoystickOneDown = 0x2f; // default
         }
      else
         scJoystickOneDown = 0x2f;

      PrfQueryProfileSize(hini, "keyboard", "JoystickOneFire", &cb);
      if (cb == sizeof(scJoystickOneFire))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "JoystickOneFire", &scJoystickOneFire, &cb))
            scJoystickOneFire = 0x2a; // default
         }
      else
         scJoystickOneFire = 0x2a;

      PrfQueryProfileSize(hini, "keyboard", "BoosterGripOneTrigger", &cb);
      if (cb == sizeof(scBoosterGripOneTrigger))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "BoosterGripOneTrigger", &scBoosterGripOneTrigger, &cb))
            scBoosterGripOneTrigger = 0x1d; // default
         }
      else
         scBoosterGripOneTrigger = 0x1d;

      PrfQueryProfileSize(hini, "keyboard", "Quit", &cb);
      if (cb == sizeof(scQuit))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "Quit", &scQuit, &cb))
            scQuit = 0x01; // default
         }
      else
         scQuit = 0x01;

      PrfQueryProfileSize(hini, "keyboard", "Select", &cb);
      if (cb == sizeof(scSelect))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "Select", &scSelect, &cb))
            scSelect = 0x3b; // default
         }
      else
         scSelect = 0x3b;

      PrfQueryProfileSize(hini, "keyboard", "Reset", &cb);
      if (cb == sizeof(scReset))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "Reset", &scReset, &cb))
            scReset = 0x3c; // default
         }
      else
         scReset = 0x3c;

      PrfQueryProfileSize(hini, "keyboard", "Color", &cb);
      if (cb == sizeof(scColor))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "Color", &scColor, &cb))
            scColor = 0x3d; // default
         }
      else
         scColor = 0x3d;

      PrfQueryProfileSize(hini, "keyboard", "BnW", &cb);
      if (cb == sizeof(scBnW))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "BnW", &scBnW, &cb))
            scBnW = 0x3e; // default
         }
      else
         scBnW = 0x3e;

      PrfQueryProfileSize(hini, "keyboard", "1A", &cb);
      if (cb == sizeof(sc1A))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "1A", &sc1A, &cb))
            sc1A = 0x3f; // default
         }
      else
         sc1A = 0x3f;

      PrfQueryProfileSize(hini, "keyboard", "1B", &cb);
      if (cb == sizeof(sc1B))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "1B", &sc1B, &cb))
            sc1B = 0x40; // default
         }
      else
         sc1B = 0x40;

      PrfQueryProfileSize(hini, "keyboard", "2A", &cb);
      if (cb == sizeof(sc2A))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "2A", &sc2A, &cb))
            sc2A = 0x41; // default
         }
      else
         sc2A = 0x41;

      PrfQueryProfileSize(hini, "keyboard", "2B", &cb);
      if (cb == sizeof(sc2B))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "2B", &sc2B, &cb))
            sc2B = 0x42; // default
         }
      else
         sc2B = 0x42;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero1", &cb);
      if (cb == sizeof(scKeyboardZero1))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero1", &scKeyboardZero1, &cb))
            scKeyboardZero1 = 0x02; // default
         }
      else
         scKeyboardZero1 = 0x02;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero2", &cb);
      if (cb == sizeof(scKeyboardZero2))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero2", &scKeyboardZero2, &cb))
            scKeyboardZero2 = 0x03; // default
         }
      else
         scKeyboardZero2 = 0x03;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero3", &cb);
      if (cb == sizeof(scKeyboardZero3))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero3", &scKeyboardZero3, &cb))
            scKeyboardZero3 = 0x04; // default
         }
      else
         scKeyboardZero3 = 0x04;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero4", &cb);
      if (cb == sizeof(scKeyboardZero4))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero4", &scKeyboardZero4, &cb))
            scKeyboardZero4 = 0x10; // default
         }
      else
         scKeyboardZero4 = 0x10;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero5", &cb);
      if (cb == sizeof(scKeyboardZero5))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero5", &scKeyboardZero5, &cb))
            scKeyboardZero5 = 0x11; // default
         }
      else
         scKeyboardZero5 = 0x11;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero6", &cb);
      if (cb == sizeof(scKeyboardZero6))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero6", &scKeyboardZero6, &cb))
            scKeyboardZero6 = 0x12; // default
         }
      else
         scKeyboardZero6 = 0x12;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero7", &cb);
      if (cb == sizeof(scKeyboardZero7))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero7", &scKeyboardZero7, &cb))
            scKeyboardZero7 = 0x1e; // default
         }
      else
         scKeyboardZero7 = 0x1e;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero8", &cb);
      if (cb == sizeof(scKeyboardZero8))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero8", &scKeyboardZero8, &cb))
            scKeyboardZero8 = 0x1f; // default
         }
      else
         scKeyboardZero8 = 0x1f;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero9", &cb);
      if (cb == sizeof(scKeyboardZero9))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero9", &scKeyboardZero9, &cb))
            scKeyboardZero9 = 0x20; // default
         }
      else
         scKeyboardZero9 = 0x20;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZeroStar", &cb);
      if (cb == sizeof(scKeyboardZeroStar))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZeroStar", &scKeyboardZeroStar, &cb))
            scKeyboardZeroStar = 0x2c; // default
         }
      else
         scKeyboardZeroStar = 0x2c;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZero0", &cb);
      if (cb == sizeof(scKeyboardZero0))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZero0", &scKeyboardZero0, &cb))
            scKeyboardZero0 = 0x2d; // default
         }
      else
         scKeyboardZero0 = 0x2d;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardZeroPound", &cb);
      if (cb == sizeof(scKeyboardZeroPound))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardZeroPound", &scKeyboardZeroPound, &cb))
            scKeyboardZeroPound = 0x2e; // default
         }
      else
         scKeyboardZeroPound = 0x2e;

      PrfQueryProfileSize(hini,"keyboard", "KeyboardOne1", &cb);
      if (cb == sizeof(scKeyboardOne1))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne1", &scKeyboardOne1, &cb))
            scKeyboardOne1 = 0x09; // default
         }
      else
         scKeyboardOne1 = 0x09;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne2", &cb);
      if (cb == sizeof(scKeyboardOne2))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne2", &scKeyboardOne2, &cb))
            scKeyboardOne2 = 0x0a; // default
         }
      else
         scKeyboardOne2 = 0x0a;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne3", &cb);
      if (cb == sizeof(scKeyboardOne3))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne3", &scKeyboardOne3, &cb))
            scKeyboardOne3 = 0x0b; // default
         }
      else
         scKeyboardOne3 = 0x0b;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne4", &cb);
      if (cb == sizeof(scKeyboardOne4))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne4", &scKeyboardOne4, &cb))
            scKeyboardOne4 = 0x17; // default
         }
      else
         scKeyboardOne4 = 0x17;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne5", &cb);
      if (cb == sizeof(scKeyboardOne5))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne5", &scKeyboardOne5, &cb))
            scKeyboardOne5 = 0x18; // default
         }
      else
         scKeyboardOne5 = 0x18;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne6", &cb);
      if (cb == sizeof(scKeyboardOne6))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne6", &scKeyboardOne6, &cb))
            scKeyboardOne6 = 0x19; // default
         }
      else
         scKeyboardOne6 = 0x19;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne7", &cb);
      if (cb == sizeof(scKeyboardOne7))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne7", &scKeyboardOne7, &cb))
            scKeyboardOne7 = 0x25; // default
         }
      else
         scKeyboardOne7 = 0x25;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne8", &cb);
      if (cb == sizeof(scKeyboardOne8))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne8", &scKeyboardOne8, &cb))
            scKeyboardOne8 = 0x26; // default
         }
      else
         scKeyboardOne8 = 0x26;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne9", &cb);
      if (cb == sizeof(scKeyboardOne9))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne9", &scKeyboardOne9, &cb))
            scKeyboardOne9 = 0x27; // default
         }
      else
         scKeyboardOne9 = 0x27;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOneStar", &cb);
      if (cb == sizeof(scKeyboardOneStar))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOneStar", &scKeyboardOneStar, &cb))
            scKeyboardOneStar = 0x33; // default
         }
      else
         scKeyboardOneStar = 0x33;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOne0", &cb);
      if (cb == sizeof(scKeyboardOne0))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOne0", &scKeyboardOne0, &cb))
            scKeyboardOne0 = 0x34; // default
         }
      else
         scKeyboardOne0 = 0x34;

      PrfQueryProfileSize(hini, "keyboard", "KeyboardOnePound", &cb);
      if (cb == sizeof(scKeyboardOnePound))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "KeyboardOnePound", &scKeyboardOnePound, &cb))
            scKeyboardOnePound = 0x35; // default
         }
      else
         scKeyboardOnePound = 0x35;

      PrfQueryProfileSize(hini, "keyboard", "NewGame", &cb);
      if (cb == sizeof(scNewGame))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "NewGame", &scNewGame, &cb))
            scNewGame = 0x68; // default
         }
      else
         scNewGame = 0x68;

      PrfQueryProfileSize(hini, "keyboard", "Pause", &cb);
      if (cb == sizeof(scPause))
         {
         if (!PrfQueryProfileData(hini,"keyboard", "Pause", &scPause, &cb))
            scPause = 0x5F; // default
         }
      else
         scPause = 0x5F;

      PrfQueryProfileSize(hini, "stella", "ShowCartNote", &cb);
      if (cb == sizeof(ShowCartNote))
         {
         if (!PrfQueryProfileData(hini,"stella", "ShowCartNote", &ShowCartNote, &cb))
            ShowCartNote = TRUE; // default
         }
      else
         ShowCartNote = TRUE;

      PrfQueryProfileSize(hini, "stella", "Paddle0", &cb);
      if (cb == sizeof(paddle[0]))
         {
         if (!PrfQueryProfileData(hini,"stella", "Paddle0", &paddle[0], &cb))
            paddle[0] = 0; // default
         }
      else
         paddle[0] = 0;

      PrfQueryProfileSize(hini, "stella", "Paddle1", &cb);
      if (cb == sizeof(paddle[1]))
         {
         if (!PrfQueryProfileData(hini,"stella", "Paddle1", &paddle[1], &cb))
            paddle[1] = 1; // default
         }
      else
         paddle[1] = 1;

      PrfQueryProfileSize(hini, "stella", "Paddle2", &cb);
      if (cb == sizeof(paddle[2]))
         {
         if (!PrfQueryProfileData(hini,"stella", "Paddle2", &paddle[2], &cb))
            paddle[2] = 2; // default
         }
      else
         paddle[2] = 2;

      PrfQueryProfileSize(hini, "stella", "Paddle3", &cb);
      if (cb == sizeof(paddle[3]))
         {
         if (!PrfQueryProfileData(hini,"stella", "Paddle3", &paddle[3], &cb))
            paddle[3] = 3; // default
         }
      else
         paddle[3] = 3;

      PrfCloseProfile(hini);
   }

   // validate defaults (in case user tweeked file on us)
   if ((maxskip < 0) || (maxskip > 15))
      maxskip = 15;
   if ((minskip < 0) || (minskip > 15))
      minskip = 0;
   if ((initskip < 0) || (initskip > 15))
      initskip = 0;
   if ((windowsize <= 1) || (windowsize > 9))
   {
      windowsize = 1;
      menubarheight = 34;
   }
   else
      menubarheight = 52;
   if ((oscilloscope < 0) || (oscilloscope > 1))
      oscilloscope = 0;

   ViewWave = 8 * oscilloscope;

   // add check for buflen
   // add check for AUDIOfreq


   // divisor value for paddle reading based on mouse's current x position on screen
   screenx      = WinQuerySysValue(HWND_DESKTOP, SV_CXSCREEN);
   screeny      = WinQuerySysValue(HWND_DESKTOP, SV_CYSCREEN);
   xborderwidth = WinQuerySysValue(HWND_DESKTOP, SV_CXSIZEBORDER);
   yborderwidth = WinQuerySysValue(HWND_DESKTOP, SV_CYSIZEBORDER);
   titleheight  = WinQuerySysValue(HWND_DESKTOP, SV_CYTITLEBAR);

   midscreenx = screenx / 2;
   midscreeny = screeny / 2;


   // open terminal session

   static ULONG flFrameFlags = FCF_TITLEBAR      | FCF_SYSMENU |    FCF_MENU   |
                               FCF_SIZEBORDER    | FCF_MINMAX  |
                               FCF_TASKLIST      | FCF_ICON ;

   if (InitializeDive() == FALSE)     //bail out if no DIVE support
      return FALSE;

   WinRegisterClass (hab, szClientClass, ClientWndProc, CS_SIZEREDRAW, 0) ;
   err = WinGetLastError(hab);
   hwndFrame = WinCreateStdWindow (HWND_DESKTOP, 0,
                                     &flFrameFlags, szClientClass, NULL,
                                     0L, 0, 444, &hwndClient);
   err = WinGetLastError(hab);

   hpsClient = WinGetPS(hwndClient);
   GpiQueryFontMetrics(hpsClient, (LONG) sizeof fm, &fm);
   infoheight = fm.lMaxBaselineExt + 4;
   if (infoheight < 26) infoheight = 26;


   if (hwndFrame)
       WinSetWindowPos(hwndFrame, NULLHANDLE, (screenx - (320 * windowsize) - 2*xborderwidth)/2,
                                              (screeny - (210 + ViewWave) * windowsize - 2*yborderwidth - titleheight - menubarheight)/2,
                                              (320 * windowsize) + 2*xborderwidth,
                                              (210 + ViewWave) * windowsize + 2*yborderwidth + titleheight + menubarheight + infoheight,
                                              SWP_SIZE|SWP_MOVE|SWP_ACTIVATE|SWP_SHOW);

   while (WinPeekMsg(hab, &qmsg, NULLHANDLE, 0, 0, PM_NOREMOVE))
       if (WinGetMsg (hab, &qmsg, NULLHANDLE, 0, 0))
            WinDispatchMsg (hab, &qmsg) ;

   OldFrameWinProc = WinSubclassWindow( hwndFrame, FrameWinKeyBypass);

   // joystick support
   JoystickInit(0,StellaIni); // Initialize joystick calibration information
   JoystickOn();
   JoystickRange(0, 1000000); // need a range for paddle support
   SizeTheWindow(hwndFrame, windowsize); // set window size multiplier

   return ((hwndFrame) ? TRUE : FALSE);
}



void SaveThrottle()
{
   HINI hini;
   string MD5;
   MD5 = theConsole->properties().get("Cartridge.MD5");
   hini = PrfOpenProfile(hab, StellaIni); // save settings
   if (hini) // load saved settings
   {
      PrfWriteProfileData(hini,"throttle", MD5.c_str(), &throttle, sizeof(throttle));
      PrfCloseProfile(hini);
   }
}

// destroy window
int CloseWindow()
{
   HINI hini;
   JoystickOff();
   JoystickSaveCalibration(StellaIni); /* save calibration info */
   hini = PrfOpenProfile(hab, StellaIni); // save settings
   if (hini) // load saved settings
   {
      PrfWriteProfileData(hini,"stella", "maxskip", &maxskip, sizeof(maxskip));
      PrfWriteProfileData(hini,"stella", "minskip", &minskip, sizeof(minskip));
      PrfWriteProfileData(hini,"stella", "initskip", &initskip, sizeof(initskip));
      PrfWriteProfileData(hini,"stella", "windowsize", &windowsize, sizeof(windowsize));
      PrfWriteProfileData(hini,"stella", "oscilloscope", &oscilloscope, sizeof(oscilloscope));
      PrfWriteProfileData(hini,"stella", "buflen", &buflen, sizeof(buflen));
      PrfWriteProfileData(hini,"stella", "AUDIOfreq", &AUDIOfreq, sizeof(AUDIOfreq));
      PrfWriteProfileData(hini,"stella", "AudioON", &AudioOK, sizeof(AudioOK));
      PrfWriteProfileData(hini,"stella", "UseCartHeight", &UseCartHeight, sizeof(UseCartHeight));
      PrfWriteProfileData(hini,"keyboard", "JoystickZeroLeft", &scJoystickZeroLeft, sizeof(scJoystickZeroLeft));
      PrfWriteProfileData(hini,"keyboard", "JoystickZeroRight", &scJoystickZeroRight, sizeof(scJoystickZeroRight));
      PrfWriteProfileData(hini,"keyboard", "JoystickZeroUp", &scJoystickZeroUp, sizeof(scJoystickZeroUp));
      PrfWriteProfileData(hini,"keyboard", "JoystickZeroDown", &scJoystickZeroDown, sizeof(scJoystickZeroDown));
      PrfWriteProfileData(hini,"keyboard", "JoystickZeroFire", &scJoystickZeroFire, sizeof(scJoystickZeroFire));
      PrfWriteProfileData(hini,"keyboard", "BoosterGripZeroTrigger", &scBoosterGripZeroTrigger, sizeof(scBoosterGripZeroTrigger));
      PrfWriteProfileData(hini,"keyboard", "JoystickOneLeft", &scJoystickOneLeft, sizeof(scJoystickOneLeft));
      PrfWriteProfileData(hini,"keyboard", "JoystickOneRight", &scJoystickOneRight, sizeof(scJoystickOneRight));
      PrfWriteProfileData(hini,"keyboard", "JoystickOneUp", &scJoystickOneUp, sizeof(scJoystickOneUp));
      PrfWriteProfileData(hini,"keyboard", "JoystickOneDown", &scJoystickOneDown, sizeof(scJoystickOneDown));
      PrfWriteProfileData(hini,"keyboard", "JoystickOneFire", &scJoystickOneFire, sizeof(scJoystickOneFire));
      PrfWriteProfileData(hini,"keyboard", "BoosterGripOneTrigger", &scBoosterGripOneTrigger, sizeof(scBoosterGripOneTrigger));
      PrfWriteProfileData(hini,"keyboard", "Quit", &scQuit, sizeof(scQuit));
      PrfWriteProfileData(hini,"keyboard", "Select", &scSelect, sizeof(scSelect));
      PrfWriteProfileData(hini,"keyboard", "Reset", &scReset, sizeof(scReset));
      PrfWriteProfileData(hini,"keyboard", "Color", &scColor, sizeof(scColor));
      PrfWriteProfileData(hini,"keyboard", "BnW", &scBnW, sizeof(scBnW));
      PrfWriteProfileData(hini,"keyboard", "1A", &sc1A, sizeof(sc1A));
      PrfWriteProfileData(hini,"keyboard", "1B", &sc1B, sizeof(sc1B));
      PrfWriteProfileData(hini,"keyboard", "2A", &sc2A, sizeof(sc2A));
      PrfWriteProfileData(hini,"keyboard", "2B", &sc2B, sizeof(sc2B));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero1", &scKeyboardZero1, sizeof(scKeyboardZero1));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero2", &scKeyboardZero2, sizeof(scKeyboardZero2));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero3", &scKeyboardZero3, sizeof(scKeyboardZero3));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero4", &scKeyboardZero4, sizeof(scKeyboardZero4));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero5", &scKeyboardZero5, sizeof(scKeyboardZero5));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero6", &scKeyboardZero6, sizeof(scKeyboardZero6));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero7", &scKeyboardZero7, sizeof(scKeyboardZero7));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero8", &scKeyboardZero8, sizeof(scKeyboardZero8));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero9", &scKeyboardZero9, sizeof(scKeyboardZero9));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZeroStar", &scKeyboardZeroStar, sizeof(scKeyboardZeroStar));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZero0", &scKeyboardZero0, sizeof(scKeyboardZero0));
      PrfWriteProfileData(hini,"keyboard", "KeyboardZeroPound", &scKeyboardZeroPound, sizeof(scKeyboardZeroPound));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne1", &scKeyboardOne1, sizeof(scKeyboardOne1));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne2", &scKeyboardOne2, sizeof(scKeyboardOne2));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne3", &scKeyboardOne3, sizeof(scKeyboardOne3));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne4", &scKeyboardOne4, sizeof(scKeyboardOne4));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne5", &scKeyboardOne5, sizeof(scKeyboardOne5));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne6", &scKeyboardOne6, sizeof(scKeyboardOne6));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne7", &scKeyboardOne7, sizeof(scKeyboardOne7));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne8", &scKeyboardOne8, sizeof(scKeyboardOne8));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne9", &scKeyboardOne9, sizeof(scKeyboardOne9));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOneStar", &scKeyboardOneStar, sizeof(scKeyboardOneStar));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOne0", &scKeyboardOne0, sizeof(scKeyboardOne0));
      PrfWriteProfileData(hini,"keyboard", "KeyboardOnePound", &scKeyboardOnePound, sizeof(scKeyboardOnePound));
      PrfWriteProfileData(hini,"keyboard", "NewGame", &scNewGame, sizeof(scNewGame));
      PrfWriteProfileData(hini,"keyboard", "Pause", &scPause, sizeof(scPause));
      PrfWriteProfileData(hini,"stella", "ShowCartNote", &ShowCartNote, sizeof(ShowCartNote));
      PrfWriteProfileData(hini,"stella", "Paddle0", &paddle[0], sizeof(paddle[0]));
      PrfWriteProfileData(hini,"stella", "Paddle1", &paddle[1], sizeof(paddle[1]));
      PrfWriteProfileData(hini,"stella", "Paddle2", &paddle[2], sizeof(paddle[2]));
      PrfWriteProfileData(hini,"stella", "Paddle3", &paddle[3], sizeof(paddle[3]));
      PrfCloseProfile(hini);
   }

   if (hDive)     DiveClose (hDive);
   if (hwndFrame) WinDestroyWindow (hwndFrame) ;
   if (hmq)       WinDestroyMsgQueue (hmq) ;
   if (hab)       WinTerminate (hab) ;


   return TRUE;
}

int different_extension(char* ext, char* file)
{
    char* extpointer = file;
    int i = strlen(file);
    extpointer += i - 4;
    return strcmp(extpointer, ext);
}


int GetCartridge(char *filename)
{
   static int Init = FALSE;
   static FILEDLG fdFileDlg;
   char pszTitle[30] = "Select Cartridge for Stella";
   static char drive[10];

   if (Init == FALSE)
   {
     memset(&fdFileDlg, 0, sizeof(FILEDLG));
     fdFileDlg.cbSize = sizeof(FILEDLG);
     fdFileDlg.fl = FDS_CENTER | FDS_PRELOAD_VOLINFO | FDS_OPEN_DIALOG;
     fdFileDlg.pszTitle = pszTitle;
     strcpy(fdFileDlg.szFullFile, "*.bin");
     Init = TRUE;
   }
    if (firstgame != 0)
    {
       strcpy(dragfilename, filename);
       firstgame = 0;
    }
   if (strcmp(dragfilename,"nada") == 0)
   {
      WinFileDlg(HWND_DESKTOP, hwndClient, &fdFileDlg);
      if (fdFileDlg.lReturn!= DID_OK)
         return FALSE;
      strcpy (filename, fdFileDlg.szFullFile);
   }
   else
   {
      strcpy (filename, dragfilename);
      strcpy (dragfilename,"nada");
   }

   char* separator = strrchr(filename, BSPF_PATH_SEPARATOR);
   char* temp;

  if(separator != 0)
  {
     strncpy(carthelppath, filename, separator - filename);
     carthelppath[separator - filename] = 0;
     strcat(carthelppath, "\\..\\docs\\");
     temp = (separator == 0) ? filename : separator + 1;
     strcpy (carthelpfile, temp);
  }
  else
  {
     carthelppath[0] = 0;
     strcpy(carthelpfile, filename);
  }

  separator = strrchr(carthelpfile, '.');
  if(separator != 0)
     strcpy(separator, ".doc");


   strcpy(carthelpfullfile,carthelppath);
   strcat(carthelpfullfile,carthelpfile);

   return TRUE;
}

// load new bitmap image in Menu
inline ChangeMenuImage(ULONG menuid, ULONG image)
{
    miItem.iPosition = 0;
    miItem.afStyle = MIS_BITMAP;
    miItem.afAttribute = 0;
    miItem.id = menuid;
    miItem.hwndSubMenu = NULLHANDLE;
    miItem.hItem = image;
    WinSendMsg(hwndMenu, MM_SETITEM, MPFROM2SHORT(0, TRUE), MPFROMP(&miItem));
    return TRUE;
}



//////////////////////////////////////////////////////////////////////
// New Game Setup
//////////////////////////////////////////////////////////////////////////////
void NewGamePrep(void)
{
   HINI hini;
   ULONG cb;
   string MD5;



   string left = theConsole->properties().get("Controller.Left");
   string right = theConsole->properties().get("Controller.Right");
   string difleft = theConsole->properties().get("Console.LeftDifficulty");
   string difright = theConsole->properties().get("Console.RightDifficulty");
   string tv = theConsole->properties().get("Console.TelevisionType");
   string format = theConsole->properties().get("Display.Format");
   CartridgeNote = theConsole->properties().get("Cartridge.Note");
   MD5 = theConsole->properties().get("Cartridge.MD5");

   const uInt32* palette = theConsole->mediaSource().palette();
   int i;

   if ((CartridgeNote != "") && (ShowCartNote))
      CartridgeNote = " -=-=-=- " + CartridgeNote + " -=-=-=- ";
   else
      CartridgeNote = "";
   stella_active = true;

   throttle = 0;
   hini = PrfOpenProfile(hab, StellaIni); // load saved settings
   if (hini)
   {
      PrfQueryProfileSize(hini, "throttle", MD5.c_str(), &cb);
      if (cb == sizeof(throttle))
      {
         if (!PrfQueryProfileData(hini,"throttle",MD5.c_str(), &throttle, &cb))
            throttle = 0; // default
      }
      else
         throttle = 0;
      PrfCloseProfile(hini);
   }


   game_paused = FALSE;
   newgame = FALSE;
   newcount = 0;

   // check game height
   if (UseCartHeight)
      theHeight = theConsole->mediaSource().height();
   else
      theHeight = 210;
   CheckWindowSize();

   if (difleft == "A" )
   {
      theEvent.set(Event::ConsoleLeftDifficultyA, 0);
      theEvent.set(Event::ConsoleLeftDifficultyB, 1);
      ChangeMenuImage(IDM_P1LEVEL, hbmcp1la);
   }
   else
   {
      theEvent.set(Event::ConsoleLeftDifficultyA, 1);
      theEvent.set(Event::ConsoleLeftDifficultyB, 0);
      ChangeMenuImage(IDM_P1LEVEL, hbmcp1lb);
   }

   if (difright == "A" )
   {
      theEvent.set(Event::ConsoleRightDifficultyA, 0);
      theEvent.set(Event::ConsoleRightDifficultyB, 1);
      ChangeMenuImage(IDM_P2LEVEL, hbmcp2la);
   }
   else
   {
      theEvent.set(Event::ConsoleRightDifficultyA, 1);
      theEvent.set(Event::ConsoleRightDifficultyB, 0);
      ChangeMenuImage(IDM_P2LEVEL, hbmcp2lb);
   }

   if (tv == "Color" )
   {
      theEvent.set(Event::ConsoleColor, 1);
      theEvent.set(Event::ConsoleBlackWhite, 0);
      ChangeMenuImage(IDM_TVTYPE, hbmctvc);
   }
   else
   {
      theEvent.set(Event::ConsoleColor, 0);
      theEvent.set(Event::ConsoleBlackWhite, 1);
      ChangeMenuImage(IDM_TVTYPE, hbmctvb);
   }

   //set left controller's status line image
   if (left == "Joystick")
      hbleft = hbjoystick;
   else if (left == "Paddles")
      hbleft = hbpaddles;
   else if (left == "Booster-Grip")
      hbleft = hbbooster;
   else if (left == "Keypad")
      hbleft = hbkeyboard;
   else if (left == "Lightgun")
      hbleft = hblightgun;
   else if (left == "Driving")
      hbleft = hbdriving;
   else if (left == "Mindlink")
      hbleft = hbmindlink;

   //set right controller's status line image
   if (right == "Joystick")
      hbright = hbjoystick;
   else if (right == "Paddles")
      hbright = hbpaddles;
   else if (right == "Booster-Grip")
      hbright = hbbooster;
   else if (right == "Keypad")
      hbright = hbkeyboard;
   else if (right == "Lightgun")
      hbright = hblightgun;
   else if (right == "Driving")
      hbright = hbdriving;
   else if (right == "Mindlink")
      hbright = hbmindlink;

   //update controller images on status line
   rcl.xLeft = 0; rcl.xRight = 32;
   rcl.yBottom = 0; rcl.yTop = 26;
   WinDrawBitmap (hpsClient, hbleft, NULL, (PPOINTL) &rcl,
                  CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

   WinQueryWindowRect (hwndClient, &rcl) ;
   rcl.xLeft = rcl.xRight - 32;
   rcl.yBottom = 0; rcl.yTop = 26;
   WinDrawBitmap (hpsClient, hbright, NULL, (PPOINTL) &rcl,
                  CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

   //set frame rate table.  0 = 60 fps, 1 = 50 fps
   if (format == "NTSC")
      frt = 0;
   else
      frt = 1;

   sprintf(szTitle,"Stella/2 - %s",theConsole->properties().get("Cartridge.Name").c_str());
   WinSetWindowText(hwndFrame, szTitle); // update window title

   // new cartridge screen inits
   titlecount = framecount = newcount = framerate = 0;
   skip = 0;        // set starting rate at 30fps
   framerate = fps[frt][skip];  // set current frame rate at 30

   Control = FALSE;

   // steal mouse pointer if paddle game
   if ((hbleft == hbpaddles) || (hbright == hbpaddles))
   {
      CartridgeNote = " -=-=-=-=-=-=- Stella/2 Note: Mouse has been captured for Paddle Emulation.  Hold <CONTROL> to release it. " + CartridgeNote;
      StealMouse = TRUE;
      WinSetCapture( HWND_DESKTOP, hwndClient);
      WinSetPointer(HWND_DESKTOP,NULL);
      WinSetPointerPos(HWND_DESKTOP, midscreenx, midscreeny);
      MouseReading = midscreenx;
   }
   else
      StealMouse = FALSE;

   // set palette - NTSC and PAL are different
   for (i = 0;i < 256;i++)
      Palette2[i] = PC_RESERVED * 16777216 + palette[i];

   DiveSetSourcePalette (hDive, 0, 256L, (PBYTE) Palette2);

   return;
}

//////////////////////////////////////////////////////////////////////////////
// Destructor
//////////////////////////////////////////////////////////////////////////////
//Terminal::~Terminal()
//{
//  ourInstanceCreated = false;
//  stella_active = FALSE;
//}


//////////////////////////////////////////////////////////////////////////////
// Update the screen with the TIA frame
//////////////////////////////////////////////////////////////////////////////
void updateDisplay()
{
   static ULONG    ulTime0, ulTime1;     /* output buffer for DosQierySysInfo      */
   static int FramesShown = 0;
   static pow[9] = {128, 112, 96, 80, 64, 48, 32, 16, 0};
   static int I, J;
   static int tc = 0;

   if ((AudioOK) && (curplaybuf))
      Tia_process(curplaybuf,buflen);

   if ((throttle>0) && (newcount&0x1))
      DosSleep(((1-skiprate[throttle & 0xf][newcount]) + (throttle >> 4))*5);

//   if (throttle>0)
//      DosSleep(((1-skiprate[throttle & 0xf][newcount]) + (throttle >> 4))*5);

   if (newcount == 0)
      if (CartridgeNote.length() > 0)
      {
         CartridgeNote = CartridgeNote.substr(1);
         {
            if (throttle > 0)
               sprintf(szTitle, "%s%2.0ffps %dT %3d%c %dx%d", CartridgeNote.c_str(),
                       framerate, throttle,
                       (int) (100 * (framerate + fps[frt][0] - fps[frt][skip]) / fps[frt][0]), '%', width, height);
            else
               sprintf(szTitle, "%s%2.0ffps %2.0ft%c %2.0fm %3d%c %dx%d", CartridgeNote.c_str(),
                       framerate, fps[frt][skip], fps[frt][maxskip],
                       (int) (100 * (framerate + 60 - fps[frt][skip]) / 60), '%', width, height);
         if (throttle > 0)
            sprintf(szTitle, "%s%2.0ffps %dT %3d%c %dx%d", CartridgeNote.c_str(),
                    framerate, throttle,
                    (int) (100 * (framerate + fps[frt][0] - fps[frt][skip]) / fps[frt][0]), '%', width, height);
         else
            sprintf(szTitle, "%s%2.0ffps %2.0ft %2.0fm %3d%c %dx%d", CartridgeNote.c_str(),
                    framerate, fps[frt][skip], fps[frt][maxskip],
                    (int) (100 * (framerate + 60 - fps[frt][skip]) / 60), '%', width, height);

            GpiCharStringPosAt(hpsClient, &ptl, &udrcl, CHS_CLIP | CHS_OPAQUE,
                               (LONG) strlen(szTitle), szTitle, NULL);
         }
      }

   //if our current skiprate value is a 1, we've got a frame to show
   if (skiprate[skip][newcount] == 1)
   {
      if(ViewWave)
         if(curplaybuf)
            for (I=0;I<8;I++)
               for(J=0;J<160;J++)
                  ViewWaveStart[J + I * 160] = ((curplaybuf[J] < pow[I]) && (curplaybuf[J] >= pow[I+1])) ? Green : Black;

      DiveBlitImage (hDive, ulDiveBufferNumber, DIVE_BUFFER_SCREEN ); //display stella frame buffer
      FramesShown++;
      if (framecount-- <= 0)   // framecounter should drop to zero once per second
      {
         //calculate FPS
         DosQuerySysInfo ( QSV_MS_COUNT, QSV_MS_COUNT, &ulTime1, 4L );
         newrate = (double) ((FramesShown * 1000) / (ulTime1 - ulTime0));
         ulTime0 = ulTime1;
         framerate = (framerate / 2) + (newrate / 2); /* age frame rate */
         FramesShown = 0;

         if (throttle > 0)
            sprintf(szTitle, "%s%2.0ffps %dT %3d%c %dx%d", CartridgeNote.c_str(),
                    framerate, throttle,
                    (int) (100 * (framerate + fps[frt][0] - fps[frt][skip]) / fps[frt][0]), '%', width, height);
         else
            sprintf(szTitle, "%s%2.0ffps %2.0ft %2.0fm %3d%c %dx%d", CartridgeNote.c_str(),
                    framerate, fps[frt][skip], fps[frt][maxskip],
                    (int) (100 * (framerate + 60 - fps[frt][skip]) / 60), '%', width, height);
         GpiCharStringPosAt(hpsClient, &ptl, &udrcl, CHS_CLIP | CHS_OPAQUE,
                            (LONG) strlen(szTitle), szTitle, NULL);


         if (throttle > 0)
         {
            if ((framerate - fps[frt][minskip])  > .4)
            {
               throttle += ((int)(framerate - fps[frt][minskip])/3);

            }
            else
               if ((fps[frt][minskip] - framerate) > .4)
               {
                  throttle -= ((int)(fps[frt][minskip] - framerate)/3);
                  if (throttle < 0) throttle = 0;
               }
         }
         else
         {
            if ((fps[frt][skip] - framerate) > fps[frt][15]) /* if emulation is to slow */
            {                                        /* fps[frt][15] is difference between adjacent fps[] values */
               if (skip < maxskip)                   /* and not at user's slowest rate */
                  skip++;                            /* choose a slower frame rate */
            }
            else
            {
               if ((framerate - fps[frt][skip]) > fps[frt][15])/* if emulation is to fast        */
                  if (skip > 0)                        /* and not already at highest fps */
                     skip--;                           /* choose a faster frame rate     */
                  else
                     throttle = 1;
            }
         }
         framecount = framerate;              /* init framecount for 1 second of frames */
      } /* end of --> if (framecount-- <= 0) */
   } /* end of --> if (skip[skip][count]) */

  ++newcount &= 0xf;    // inc counter by 1 & limit values from 0-15

  if (resetmenukey15 != 0)
     theEvent.set((Event::Type)resetmenukey15, 0);

  // age the resetmenukey (if reset right away then some games don't recognize the menu bar select/reset
  resetmenukey15 = resetmenukey14;
  resetmenukey14 = resetmenukey13;
  resetmenukey13 = resetmenukey12;
  resetmenukey12 = resetmenukey11;
  resetmenukey11 = resetmenukey10;
  resetmenukey10 = resetmenukey9;
  resetmenukey9 = resetmenukey8;
  resetmenukey8 = resetmenukey7;
  resetmenukey7 = resetmenukey6;
  resetmenukey6 = resetmenukey5;
  resetmenukey5 = resetmenukey4;
  resetmenukey4 = resetmenukey3;
  resetmenukey3 = resetmenukey2;
  resetmenukey2 = resetmenukey1;
  resetmenukey1 = resetmenukey;
  resetmenukey = 0;

  handleEvents();    // always process keyboard and window events, even if screen not updated
}

//////////////////////////////////////////////////////////////////////////////
// Process any events related to the terminal
//////////////////////////////////////////////////////////////////////////////
void handleEvents()
{
   static POINTL ptl;
   static Int32 joymin[4]={65536,65536,65536,65536};
   static Int32 joymax[4]={0,0,0,0};
   static int percent;
   static JOYSTICK_STATUS stick;
   static uInt32 resistance;
   static LONG mb;


loop:
   if (WinPeekMsg(hab, &qmsg, NULLHANDLE, 0, 0, PM_NOREMOVE))
      if (WinGetMsg (hab, &qmsg, NULLHANDLE, 0, 0))
         WinDispatchMsg (hab, &qmsg) ;
      else
         theQuitIndicator = TRUE;

   // don't let messages queue up
   if (WinPeekMsg(hab, &qmsg, NULLHANDLE, 0, 0, PM_NOREMOVE)) goto loop;

   while (game_paused)
   {
      if (curplaybuf) memset(curplaybuf,0,buflen);  // kill sound when paused
      if (WinGetMsg (hab, &qmsg, NULLHANDLE, 0, 0))
         WinDispatchMsg (hab, &qmsg);
      else
      {
         theQuitIndicator = TRUE;
         game_paused = FALSE;
      }
   }

   if ((StealMouse) && (!Control))
   {
      WinQueryPointerPos(HWND_DESKTOP, &ptl);
      MouseReading += (ptl.x - midscreenx);
      if (!Control) WinSetPointerPos(HWND_DESKTOP, midscreenx, midscreeny);
      mb = WinGetKeyState(HWND_DESKTOP, VK_BUTTON1); // status of mouse button 1

      if (MouseReading < 0) MouseReading = 0;
      if (MouseReading > screenx) MouseReading = screenx;

      resistance = (uInt32) (1000000 * (screenx-MouseReading) / screenx);

      if (paddle[0] == 0)
      {
         theEvent.set(Event::PaddleZeroResistance, resistance);
         theEvent.set(Event::PaddleZeroFire, (mb & 0x8000)?1:0);
      }
      if (paddle[1] == 0)
      {
         theEvent.set(Event::PaddleOneResistance, resistance);
         theEvent.set(Event::PaddleOneFire, (mb & 0x8000)?1:0);
      }
      if (paddle[2] == 0)
      {
         theEvent.set(Event::PaddleTwoResistance, resistance);
         theEvent.set(Event::PaddleTwoFire, (mb & 0x8000)?1:0);
      }
      if (paddle[3] == 0)
      {
         theEvent.set(Event::PaddleThreeResistance, resistance);
         theEvent.set(Event::PaddleThreeFire, (mb & 0x8000)?1:0);
      }
   }

   if (JoystickValues(&stick))
   {
      if (hbleft == hbjoystick)
      {
         theEvent.set(Event::JoystickZeroLeft,  (stick.Joy1X < 300000) ? 1:keyboardEvent.get(Event::JoystickZeroLeft));
         theEvent.set(Event::JoystickZeroRight, (stick.Joy1X > 700000) ? 1:keyboardEvent.get(Event::JoystickZeroRight));
         theEvent.set(Event::JoystickZeroUp,    (stick.Joy1Y < 300000) ? 1:keyboardEvent.get(Event::JoystickZeroUp));
         theEvent.set(Event::JoystickZeroDown,  (stick.Joy1Y > 700000) ? 1:keyboardEvent.get(Event::JoystickZeroDown));
         theEvent.set(Event::JoystickZeroFire,  (stick.Joy1A|stick.Joy1B)?1:keyboardEvent.get(Event::JoystickZeroFire));
      }
      else if(hbleft == hbdriving)
      {  // doesn't use DrivingZero... Events
         theEvent.set(Event::JoystickZeroLeft,  (stick.Joy1X < 300000) ? 1:keyboardEvent.get(Event::JoystickZeroLeft));
         theEvent.set(Event::JoystickZeroRight, (stick.Joy1X > 700000) ? 1:keyboardEvent.get(Event::JoystickZeroRight));
         theEvent.set(Event::JoystickZeroFire,  (stick.Joy1A|stick.Joy1B)?1:keyboardEvent.get(Event::JoystickZeroFire));
      }
      else if(hbleft == hbbooster)
      {
         theEvent.set(Event::JoystickZeroLeft,  (stick.Joy1X < 300000) ? 1:keyboardEvent.get(Event::JoystickZeroLeft));
         theEvent.set(Event::JoystickZeroRight, (stick.Joy1X > 700000) ? 1:keyboardEvent.get(Event::JoystickZeroRight));
         theEvent.set(Event::JoystickZeroUp,    (stick.Joy1Y < 300000) ? 1:keyboardEvent.get(Event::JoystickZeroUp));
         theEvent.set(Event::JoystickZeroDown,  (stick.Joy1Y > 700000) ? 1:keyboardEvent.get(Event::JoystickZeroDown));
         theEvent.set(Event::BoosterGripZeroTrigger,  (stick.Joy1A)?1:keyboardEvent.get(Event::BoosterGripZeroTrigger));
         theEvent.set(Event::BoosterGripZeroBooster,  (stick.Joy1B)?1:keyboardEvent.get(Event::BoosterGripZeroBooster));
      }


      if (hbright == hbjoystick)
      {
         theEvent.set(Event::JoystickOneFire,   (stick.Joy2A|stick.Joy2B)?1:keyboardEvent.get(Event::JoystickOneFire));
         theEvent.set(Event::JoystickOneLeft,   (stick.Joy2X < 300000) ? 1:keyboardEvent.get(Event::JoystickOneLeft));
         theEvent.set(Event::JoystickOneRight,  (stick.Joy2X > 700000) ? 1:keyboardEvent.get(Event::JoystickOneRight));
         theEvent.set(Event::JoystickOneUp,     (stick.Joy2Y < 300000) ? 1:keyboardEvent.get(Event::JoystickOneUp));
         theEvent.set(Event::JoystickOneDown,   (stick.Joy2Y > 700000) ? 1:keyboardEvent.get(Event::JoystickOneDown));
      }
      else if(hbright == hbdriving)
      {
         theEvent.set(Event::JoystickOneLeft,   (stick.Joy2X < 300000) ? 1:keyboardEvent.get(Event::JoystickOneLeft));
         theEvent.set(Event::JoystickOneRight,  (stick.Joy2X > 700000) ? 1:keyboardEvent.get(Event::JoystickOneRight));
         theEvent.set(Event::JoystickOneFire,   (stick.Joy2A|stick.Joy2B)?1:keyboardEvent.get(Event::JoystickOneFire));
      }
      else if (hbright == hbbooster)
      {
         theEvent.set(Event::JoystickOneLeft,   (stick.Joy2X < 300000) ? 1:keyboardEvent.get(Event::JoystickOneLeft));
         theEvent.set(Event::JoystickOneRight,  (stick.Joy2X > 700000) ? 1:keyboardEvent.get(Event::JoystickOneRight));
         theEvent.set(Event::JoystickOneUp,     (stick.Joy2Y < 300000) ? 1:keyboardEvent.get(Event::JoystickOneUp));
         theEvent.set(Event::JoystickOneDown,   (stick.Joy2Y > 700000) ? 1:keyboardEvent.get(Event::JoystickOneDown));
         theEvent.set(Event::BoosterGripOneTrigger,  (stick.Joy2A)?1:keyboardEvent.get(Event::BoosterGripOneTrigger));
         theEvent.set(Event::BoosterGripOneBooster,  (stick.Joy2B)?1:keyboardEvent.get(Event::BoosterGripOneBooster));
      }

      // joystick 1 for paddle
      if (paddle[0] == 1)
      {
         theEvent.set(Event::PaddleZeroResistance, 1000000 - stick.Joy1X);
         theEvent.set(Event::PaddleZeroFire, (stick.Joy1A|stick.Joy1B)?1:0);
      }
      if (paddle[1] == 1)
      {
         theEvent.set(Event::PaddleOneResistance, 1000000 - stick.Joy1X);
         theEvent.set(Event::PaddleOneFire, (stick.Joy1A|stick.Joy1B)?1:0);
      }
      if (paddle[2] == 1)
      {
         theEvent.set(Event::PaddleTwoResistance, 1000000 - stick.Joy1X);
         theEvent.set(Event::PaddleTwoFire, (stick.Joy1A|stick.Joy1B)?1:0);
      }
      if (paddle[3] == 1)
      {
         theEvent.set(Event::PaddleThreeResistance, 1000000 - stick.Joy1X);
         theEvent.set(Event::PaddleThreeFire, (stick.Joy1A|stick.Joy1B)?1:0);
      }

      // Joystick 2 for paddle
      if (paddle[0] == 2)
      {
         theEvent.set(Event::PaddleZeroResistance, 1000000 - stick.Joy2X);
         theEvent.set(Event::PaddleZeroFire, (stick.Joy2A|stick.Joy2B)?1:0);
      }
      if (paddle[1] == 2)
      {
         theEvent.set(Event::PaddleOneResistance, 1000000 - stick.Joy2X);
         theEvent.set(Event::PaddleOneFire, (stick.Joy2A|stick.Joy2B)?1:0);
      }
      if (paddle[2] == 2)
      {
         theEvent.set(Event::PaddleTwoResistance, 1000000 - stick.Joy2X);
         theEvent.set(Event::PaddleTwoFire, (stick.Joy2A|stick.Joy2B)?1:0);
      }
      if (paddle[3] == 2)
      {
         theEvent.set(Event::PaddleThreeResistance, 1000000 - stick.Joy2X);
         theEvent.set(Event::PaddleThreeFire, (stick.Joy2A|stick.Joy2B)?1:0);
      }

      // real paddle
      if (paddle[0] == 4)
      {
         theEvent.set(Event::PaddleZeroResistance, 1000000 - stick.Joy1X);
         theEvent.set(Event::PaddleZeroFire, (stick.Joy1A)?1:0);
      }
      if (paddle[1] == 4)
      {
         theEvent.set(Event::PaddleOneResistance, 1000000 - stick.Joy1Y);
         theEvent.set(Event::PaddleOneFire, (stick.Joy1B)?1:0);
      }
      if (paddle[2] == 4)
      {
         theEvent.set(Event::PaddleTwoResistance, 1000000 - stick.Joy2X);
         theEvent.set(Event::PaddleTwoFire, (stick.Joy2A)?1:0);
      }
      if (paddle[3] == 4)
      {
         theEvent.set(Event::PaddleThreeResistance, 1000000 - stick.Joy2Y);
         theEvent.set(Event::PaddleThreeFire, (stick.Joy2B)?1:0);
      }
   }
}


void CheckWindowSize(void)
{

   if (theHeight != scrHEIGHT)
   {
      scrHEIGHT = theHeight;
      SizeTheWindow(hwndFrame, 0);
   }
   ViewWaveStart = XBuf + 160 * scrHEIGHT;
}

MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
      int difleft, difright, tv;
      int x, y;
      int i; //, i2;
      char scancode;
      static HBITMAP hbm;
      static BITMAPINFOHEADER2 bmp;
      static RECTL          rcl;
      static RECTL          flip;
      char key;
      char vkey;
      WNDPARAMS *pwprm;
      HWND hwndFrame3;

      //added w/dive routines
      SIZEL              sizl;
      ULONG              ulcPaletteColors = 256;
      POINTL             pointl;         // Point to offset from Desktop
      SWP                swp;            // Window position
      HRGN               hrgn;           // Region handle
      RECTL              rcls[50];       // Rectangle coordinates
      RGNRECT            rgnCtl;         // Processing control structure
      SETUP_BLITTER      SetupBlitter;   // structure for DiveSetupBlitter
      static HPS         hpsMainHPS;

      PDRAGINFO pDragInfo;
      PDRAGITEM pDragItem;
      char dragname[CCHMAXPATH];

      STARTDATA   sd;
      PID         procID;
      ULONG       sessID;
      APIRET      rc;
      APIRET      arReturn;
      FILESTATUS3 fsStatus;
      ULONG  action; // only used for DosOpen

     switch (msg)
          {
          case WM_COMMAND:
             switch (COMMANDMSG(&msg)->cmd)
             {
                case IDM_NEWCART: theQuitIndicator = TRUE;
                                  newgame = TRUE;
                                  game_paused = 0;
                                  if (curplaybuf) memset(curplaybuf,0,buflen);
                                  ChangeMenuImage(IDM_NEWCART, hbmcng);
                                  break;

                case IDM_TVTYPE:  tv = theEvent.get(Event::ConsoleColor);
                                  if (tv == 1)
                                  {
                                     theEvent.set(Event::ConsoleColor, 0);
                                     theEvent.set(Event::ConsoleBlackWhite, 1);
                                     ChangeMenuImage(IDM_TVTYPE, hbmctvb);
                                  }
                                  else
                                  {
                                     theEvent.set(Event::ConsoleColor, 1);
                                     theEvent.set(Event::ConsoleBlackWhite, 0);
                                     ChangeMenuImage(IDM_TVTYPE, hbmctvc);
                                  }
                                  break;

                case IDM_P1LEVEL: difleft = theEvent.get(Event::ConsoleLeftDifficultyA);
                                  if (difleft == 1)
                                  {
                                     theEvent.set(Event::ConsoleLeftDifficultyA, 0);
                                     theEvent.set(Event::ConsoleLeftDifficultyB, 1);
                                     ChangeMenuImage(IDM_P1LEVEL, hbmcp1la);
                                  }
                                  else
                                  {
                                     theEvent.set(Event::ConsoleLeftDifficultyA, 1);
                                     theEvent.set(Event::ConsoleLeftDifficultyB, 0);
                                     ChangeMenuImage(IDM_P1LEVEL, hbmcp1lb);
                                  }
                                  break;

                case IDM_P2LEVEL: difright = theEvent.get(Event::ConsoleRightDifficultyA);
                                  if (difright == 1)
                                  {
                                     theEvent.set(Event::ConsoleRightDifficultyA, 0);
                                     theEvent.set(Event::ConsoleRightDifficultyB, 1);
                                     ChangeMenuImage(IDM_P2LEVEL, hbmcp2la);
                                  }
                                  else
                                  {
                                     theEvent.set(Event::ConsoleRightDifficultyA, 1);
                                     theEvent.set(Event::ConsoleRightDifficultyB, 0);
                                     ChangeMenuImage(IDM_P2LEVEL, hbmcp2lb);
                                  }
                                  break;

                case IDM_SELECT:  theEvent.set(Event::ConsoleSelect, 1);
                                  resetmenukey = Event::ConsoleSelect;
                                  ChangeMenuImage(IDM_SELECT, hbmcslct);
                                  break;

                case IDM_RESET:   theEvent.set(Event::ConsoleReset, 1);
                                  resetmenukey = Event::ConsoleReset;
                                  ChangeMenuImage(IDM_RESET, hbmcrst);
                                  break;

                case IDM_SETTING:
                              db_frt = frt; // initialize to current settings
                              db_min = maxskip; // min frame rate defined by maximum skip value
                              db_max = minskip; // maximum frame rate defined by minimum skip value
                              db_init = initskip;
                              db_size = windowsize;
                              db_osc = oscilloscope;
                              db_buffer = buflen;
                              db_volume = AudioOK;
                              db_frequency = AUDIOfreq;
                              db_paddle0 = paddle[0];
                              db_paddle1 = paddle[1];
                              db_paddle2 = paddle[2];
                              db_paddle3 = paddle[3];
                              db_height = UseCartHeight;
                              db_note = ShowCartNote;
                              if (curplaybuf) memset(curplaybuf,0,buflen);  // kill sound when paused
                              WinDlgBox(HWND_DESKTOP, hwnd, DlgProc, NULLHANDLE, DB_MAIN, NULL);
                              if (db_OK == TRUE)
                              {
                                 frt = db_frt; // set to new settings
                                 maxskip = db_min;
                                 minskip = db_max;
                                 skip = db_init;
                                 paddle[0] = db_paddle0;
                                 paddle[1] = db_paddle1;
                                 paddle[2] = db_paddle2;
                                 paddle[3] = db_paddle3;
                                 ShowCartNote = db_note;
                                 if ((windowsize != db_size) || (oscilloscope != db_osc) ||
                                     (UseCartHeight != db_height))
                                 {
                                    UseCartHeight = db_height;
                                    windowsize = db_size;
                                    oscilloscope = db_osc;
                                    if (UseCartHeight)
                                       theHeight = theConsole->mediaSource().height();
                                    else
                                       theHeight = 210;
                                    if (theHeight != scrHEIGHT)
                                    scrHEIGHT = theHeight;
                                    ViewWave = db_osc * 8;
                                    ViewWaveStart = XBuf + 160 * scrHEIGHT;
                                    SizeTheWindow(hwnd, db_size);
                                 }
                                 if ((db_volume != AudioOK) || (db_frequency != AUDIOfreq) || (db_buffer != buflen))
                                 {
                                    audio_close();
                                    AudioOK = db_volume;
                                    AUDIOfreq = db_frequency;
                                    buflen = db_buffer;
                                    if (db_volume != 0)
                                       audio_init();
                                 }
                              }
                if (StealMouse)
                {
                   WinSetCapture( HWND_DESKTOP, hwndClient);
                   WinSetPointer(HWND_DESKTOP,NULL);
                   WinSetPointerPos(HWND_DESKTOP, midscreenx, midscreeny);
                   Control = FALSE;
                }

                              break;


                case IDM_GAMEHELP:
                                  arReturn = DosQueryPathInfo(carthelpfullfile, FIL_STANDARD, &fsStatus, sizeof(fsStatus));
                                  if (arReturn != 0)
                                    WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, (PSZ)carthelpfile, (PSZ)"No helpfile found for this game!", 0, MB_OK | MB_INFORMATION );
                                  else
                                  {
                                    sprintf(dragname, "\"%s\"", carthelpfullfile);
                                    JoystickOff();
                                    procID = 0;
                                    sessID = 0;
                                    memset(&sd, 0, sizeof(STARTDATA));
                                    sd.PgmName = "E.EXE";
                                    sd.PgmInputs = dragname; //carthelpfullfile;
                                    sd.SessionType = SSF_TYPE_PM;
                                    sd.Length = sizeof(STARTDATA);
                                    sd.Related = SSF_RELATED_INDEPENDENT;
                                    sd.FgBg = SSF_FGBG_FORE;
                                    sd.TraceOpt = SSF_TRACEOPT_NONE;
                                    sd.TermQ = 0;
                                    sd.Environment = NULL;
                                    sd.InheritOpt = SSF_INHERTOPT_PARENT;
                                    sd.PgmControl = SSF_CONTROL_VISIBLE | SSF_CONTROL_MAXIMIZE;
                                    sd.InitXPos = 10;
                                    sd.InitYPos = 10;
                                    sd.InitXSize = 400;
                                    sd.InitYSize = 600;
                                    sd.Reserved = 0;
                                    sd.ObjectBuffer = NULL;
                                    sd.ObjectBuffLen = 0;
                                    rc = DosStartSession(&sd, &sessID, &procID);
                                    DosSleep(5000);
                                    JoystickOn();                                  }
                                  break;

                case IDM_STELLAHELP:
                                  arReturn = DosQueryPathInfo(StellaHelp, FIL_STANDARD, &fsStatus, sizeof(fsStatus));
                                  if (arReturn != 0)
                                     WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, StellaHelp, (PSZ)"File is missing!", 0, MB_OK | MB_INFORMATION );
                                  else
                                  {
                                    sprintf(dragname, "\"%s\"", StellaHelp);
                                    JoystickOff();
                                    procID = 0;
                                    sessID = 0;
                                    memset(&sd, 0, sizeof(STARTDATA));
                                    sd.PgmName = "VIEW.EXE";
                                    sd.PgmInputs = dragname; // StellaHelp;
                                    sd.SessionType = SSF_TYPE_PM;
                                    sd.Length = sizeof(STARTDATA);
                                    sd.Related = SSF_RELATED_INDEPENDENT;
                                    sd.FgBg = SSF_FGBG_FORE;
                                    sd.TraceOpt = SSF_TRACEOPT_NONE;
                                    sd.TermQ = 0;
                                    sd.Environment = NULL;
                                    sd.InheritOpt = SSF_INHERTOPT_PARENT;
                                    sd.PgmControl = SSF_CONTROL_VISIBLE | SSF_CONTROL_MAXIMIZE;
                                    sd.InitXPos = 10;
                                    sd.InitYPos = 10;
                                    sd.InitXSize = 400;
                                    sd.InitYSize = 600;
                                    sd.Reserved = 0;
                                    sd.ObjectBuffer = NULL;
                                    sd.ObjectBuffLen = 0;
                                    rc = DosStartSession(&sd, &sessID, &procID);
                                    DosSleep(5000);
                                    JoystickOn();                                  }
                                  break;
             }
          case WM_CREATE:

             if (stella_active == FALSE)
             {
               hps = WinGetPS (hwnd) ;
               hbm = GpiLoadBitmap (hps, 0, START_BMP, 0L, 0L);
               // load the small menu bitmaps and make them current
               hbmctvc  = hbmstvc  = GpiLoadBitmap (hps, 0, TVTYPEC_BMP, 0L, 0L);
               hbmctvb  = hbmstvb  = GpiLoadBitmap (hps, 0, TVTYPEB_BMP, 0L, 0L);
               hbmcp1la = hbmsp1la = GpiLoadBitmap (hps, 0, P1LVLA_BMP,  0L, 0L);
               hbmcp1lb = hbmsp1lb = GpiLoadBitmap (hps, 0, P1LVLB_BMP,  0L, 0L);
               hbmcp2la = hbmsp2la = GpiLoadBitmap (hps, 0, P2LVLA_BMP,  0L, 0L);
               hbmcp2lb = hbmsp2lb = GpiLoadBitmap (hps, 0, P2LVLB_BMP,  0L, 0L);
               hbmcng   = hbmsng   = GpiLoadBitmap (hps, 0, NEWGAME_BMP, 0L, 0L);
               hbmcslct = hbmsslct = GpiLoadBitmap (hps, 0, SELECT_BMP,  0L, 0L);
               hbmcrst  = hbmsrst  = GpiLoadBitmap (hps, 0, RESET_BMP,   0L, 0L);
               hbmcset  = hbmsset  = GpiLoadBitmap (hps, 0, SETTING_BMP, 0L, 0L);

               hbmccrt  = hbmscrt  = GpiLoadBitmap (hps, 0, CARTHLP_BMP, 0L, 0L);
               hbmchlp  = hbmshlp  = GpiLoadBitmap (hps, 0, STELHLP_BMP, 0L, 0L);
               // load the medium menu bitmaps
               hbmmng   = GpiLoadBitmap (hps, 0, MNEWGAME_BMP, 0L, 0L);
               hbmmtvc  = GpiLoadBitmap (hps, 0, MTVTYPEC_BMP, 0L, 0L);
               hbmmtvb  = GpiLoadBitmap (hps, 0, MTVTYPEB_BMP, 0L, 0L);
               hbmmp1la = GpiLoadBitmap (hps, 0, MP1LVLA_BMP,  0L, 0L);
               hbmmp1lb = GpiLoadBitmap (hps, 0, MP1LVLB_BMP,  0L, 0L);
               hbmmp2la = GpiLoadBitmap (hps, 0, MP2LVLA_BMP,  0L, 0L);
               hbmmp2lb = GpiLoadBitmap (hps, 0, MP2LVLB_BMP,  0L, 0L);
               hbmmslct = GpiLoadBitmap (hps, 0, MSELECT_BMP,  0L, 0L);
               hbmmrst  = GpiLoadBitmap (hps, 0, MRESET_BMP,   0L, 0L);
               hbmmset  = GpiLoadBitmap (hps, 0, MSETTING_BMP, 0L, 0L);
               hbmmcrt  = GpiLoadBitmap (hps, 0, MCARTHLP_BMP, 0L, 0L);
               hbmmhlp  = GpiLoadBitmap (hps, 0, MSTELHLP_BMP, 0L, 0L);
               // load the controller bitmaps
               hbleft = hbright = hbjoystick = GpiLoadBitmap (hps, 0, JOYSTICK_BMP, 0L, 0L);
               hbbooster  = GpiLoadBitmap (hps, 0, BOOSTER_BMP, 0L, 0L);
               hbkeyboard = GpiLoadBitmap (hps, 0, KEYBOARD_BMP, 0L, 0L);
               hbpaddles  = GpiLoadBitmap (hps, 0, PADDLES_BMP, 0L, 0L);
               hblightgun = GpiLoadBitmap (hps, 0, LIGHTGUN_BMP, 0L, 0L);
               hbmindlink = GpiLoadBitmap (hps, 0, MINDLINK_BMP, 0L, 0L);
               hbdriving  = GpiLoadBitmap (hps, 0, DRIVING_BMP, 0L, 0L);
               hwndMenu = WinWindowFromID(WinQueryWindow(hwnd, QW_PARENT), FID_MENU);
               WinReleasePS (hps) ;
             }

             sizl.cx = sizl.cy = 0;
             hdcClientHDC = WinOpenWindowDC (hwnd);
             hpsMainHPS = GpiCreatePS (hab, hdcClientHDC, &sizl,
                           PU_PELS | GPIF_DEFAULT | GPIT_MICRO | GPIA_ASSOC);

             hpalMain = GpiCreatePalette (hab,
                                    LCOL_PURECOLOR,
                                    LCOLF_CONSECRGB,
                                    ulcPaletteColors,
                                    (PULONG) Palette2);

             GpiSelectPalette (hpsMainHPS, hpalMain);
             WinRealizePalette (hwnd, hps, &ulcPaletteColors);

             DiveSetSourcePalette (hDive, 0, 256L, (PBYTE) Palette2);
             DiveSetDestinationPalette (hDive, 0, 256, 0 );

             pbmi = (BITMAPINFO2 *) malloc(sizeof(BITMAPINFO2) + sizeof (RGB2) * 255);
             memset(pbmi, 0, sizeof(BITMAPINFOHEADER2)); // init to all 0's
             pbmi->cbFix   = sizeof(BITMAPINFOHEADER2);
             pbmi->cx      = 160;
             pbmi->cy      = 210;
             pbmi->cPlanes = 1;
             pbmi->cBitCount = 8;
             for (i=0;i<256;i++)
                {
                 pbmi->argbColor[i].bRed = Palette2[i * 4 + 2 ] ;
                 pbmi->argbColor[i].bGreen = Palette2[i * 4 + 1];
                 pbmi->argbColor[i].bBlue = Palette2[i * 4]      ;
                 pbmi->argbColor[i].fcOptions = 0;
                }
              WinQueryWindowRect (hwnd, &rcl);
                   width = rcl.xRight;
                   height = rcl.yTop - infoheight;
                   aptl[0].x = 32;aptl[0].y = 0;
                   aptl[1].x = width-33;aptl[1].y = 0;
                   aptl[2].x = width-33;aptl[2].y = infoheight - 2;
                   GpiSetColor(hpsClient, CLR_WHITE);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[1].x = 32;aptl[1].y = infoheight - 2;
                   aptl[2].x = 32;aptl[2].y = 0;
                   GpiSetColor(hpsClient, CLR_DARKGRAY);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[0].x = 32;         aptl[0].y = infoheight - 1;
                   aptl[1].x = width - 33; aptl[1].y = infoheight - 1;
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiLine(hpsClient, &aptl[1]);

                   GpiSetBackColor(hpsClient, CLR_PALEGRAY);
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   ptl.x = 34; ptl.y = fm.lMaxDescender + 1;
                   udrcl.xLeft = 33; udrcl.yBottom = 1;
                   udrcl.xRight = width-34; udrcl.yTop = infoheight-3;

                   aptl[0].x = 33; aptl[0].y = 1;
                   aptl[1].x = width - 34; aptl[1].y = infoheight - 3;
                   GpiMove(hpsClient, &aptl[0]);
                   GpiBox(hpsClient, DRO_FILL, &aptl[1], 0L, 0L);
                   GpiSetColor(hpsClient, CLR_DARKBLUE);

                   rcl.xLeft = 0; rcl.xRight = 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbleft, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

                   WinQueryWindowRect (hwnd, &rcl) ;
                   rcl.xLeft = rcl.xRight - 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbright, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;


             return 0 ;
          case DM_DRAGOVER:
               pDragInfo = (PDRAGINFO) mp1;
               DrgAccessDraginfo(pDragInfo);
               pDragItem = DrgQueryDragitemPtr(pDragInfo, 0);
               DrgQueryStrName(pDragItem->hstrSourceName, CCHMAXPATH, dragname);

               /* exclude multi select & not snapshot/tap */
              if((pDragInfo->cditem > 1)||
                ((different_extension(".bin", dragname)) && (different_extension(".BIN", dragname))))
                 return (MPFROM2SHORT (DOR_NEVERDROP, DO_UNKNOWN));
              else
                  return (MPFROM2SHORT (DOR_DROP, DO_UNKNOWN));
               break;

          case DM_DROP:
               pDragInfo = (PDRAGINFO)mp1;
               DrgAccessDraginfo(pDragInfo);
               pDragItem = DrgQueryDragitemPtr(pDragInfo, 0);
               DrgQueryStrName(pDragItem->hstrContainerName, CCHMAXPATH, dragname);
               DrgQueryStrName(pDragItem->hstrSourceName, CCHMAXPATH, dragname+strlen(dragname));

               strcpy(dragfilename, dragname);
               newgame = TRUE;
               if (curplaybuf) memset(curplaybuf,0,buflen);
               theQuitIndicator = TRUE;
               WinSetFocus(HWND_DESKTOP, hwnd);
               break;

          case WM_PAINT:
               if (stella_active)
               {
                  hps = WinBeginPaint (hwnd, NULLHANDLE, NULL);
                  DiveBlitImage (hDive, ulDiveBufferNumber, DIVE_BUFFER_SCREEN );
                  WinEndPaint (hps);
               }
               else
                  if (hwnd == hwndClient)
                  {
                      hps = WinBeginPaint (hwnd, NULLHANDLE, NULL) ;
                      GpiErase (hps) ;
                      WinQueryWindowRect (hwnd, &rcl) ;
                      rcl.yBottom = infoheight;
                      WinDrawBitmap (hps, hbm, NULL, (PPOINTL) &rcl,
                                   CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;
//                      DosSleep(500);
                     WinEndPaint (hps) ;
                   }
                   else
                  {
                      hps = WinBeginPaint (hwnd, NULLHANDLE, NULL) ;
                      GpiErase (hps) ;
                      WinEndPaint (hps) ;
                   }
                WinQueryWindowRect (hwnd, &rcl);

                width = rcl.xRight;
                height = rcl.yTop - infoheight;
                aptl[0].x = 32;aptl[0].y = 0;
                aptl[1].x = width-33;aptl[1].y = 0;
                aptl[2].x = width-33;aptl[2].y = infoheight - 2;
                GpiSetColor(hpsClient, CLR_WHITE);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[1].x = 32;aptl[1].y = infoheight - 2;
                   aptl[2].x = 32;aptl[2].y = 0;
                   GpiSetColor(hpsClient, CLR_DARKGRAY);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[0].x = 32;         aptl[0].y = infoheight - 1;
                   aptl[1].x = width - 33; aptl[1].y = infoheight - 1;
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiLine(hpsClient, &aptl[1]);

                   GpiSetBackColor(hpsClient, CLR_PALEGRAY);
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   ptl.x = 34; ptl.y = fm.lMaxDescender + 1;
                   udrcl.xLeft = 33; udrcl.yBottom = 1;
                   udrcl.xRight = width-34; udrcl.yTop = infoheight-3;

                   aptl[0].x = 33; aptl[0].y = 1;
                   aptl[1].x = width - 34; aptl[1].y = infoheight - 3;
                   GpiMove(hpsClient, &aptl[0]);
                   GpiBox(hpsClient, DRO_FILL, &aptl[1], 0L, 0L);
                   GpiSetColor(hpsClient, CLR_DARKBLUE);

                   rcl.xLeft = 0; rcl.xRight = 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbleft, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

                   WinQueryWindowRect (hwnd, &rcl) ;
                   rcl.xLeft = rcl.xRight - 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbright, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;
                   if (game_paused)
                   {
                      sprintf(szTitle, "-=> PAUSED <=-");
                      GpiCharStringPosAt(hpsClient, &ptl, &udrcl, CHS_CLIP | CHS_OPAQUE, (LONG) strlen(szTitle), szTitle, NULL);
                   }
                   return 0 ;



          case WM_SIZE:

                if (theConsole == NULL)
                {
                   difleft = difright = 0;
                   tv = 1;
                }
                else
                {
                   difleft = theEvent.get(Event::ConsoleLeftDifficultyA);
                   difright = theEvent.get(Event::ConsoleRightDifficultyA);
                   tv = theEvent.get(Event::ConsoleColor);
                }

             WinQueryWindowRect (hwnd, &rcl);

             // force update of window title display
             titlecount = framecount = newcount = 0;

             width = rcl.xRight;
             height = rcl.yTop;
             if (width >= 640)
             { // select medium sized menu buttons
               hbmcng   = hbmmng  ;
               hbmctvc  = hbmmtvc ;
               hbmctvb  = hbmmtvb ;
               hbmcp1la = hbmmp1la;
               hbmcp1lb = hbmmp1lb;
               hbmcp2la = hbmmp2la;
               hbmcp2lb = hbmmp2lb;
               hbmcslct = hbmmslct;
               hbmcrst  = hbmmrst ;
               hbmcset  = hbmmset ;
               hbmccrt  = hbmmcrt ;
               hbmchlp  = hbmmhlp ;
               menubarheight = 52;
             }
             else
             { // select small menu buttons
               hbmcng   = hbmsng  ;
               hbmctvc  = hbmstvc ;
               hbmctvb  = hbmstvb ;
               hbmcp1la = hbmsp1la;
               hbmcp1lb = hbmsp1lb;
               hbmcp2la = hbmsp2la;
               hbmcp2lb = hbmsp2lb;
               hbmcslct = hbmsslct;
               hbmcrst  = hbmsrst ;
               hbmcset  = hbmsset ;
               hbmccrt  = hbmscrt ;
               hbmchlp  = hbmshlp ;
               menubarheight = 34;
             }
             // redraw all buttons in case button size changed
             ChangeMenuImage(IDM_NEWCART,    hbmcng);

   if (difleft == 0)
      ChangeMenuImage(IDM_P1LEVEL, hbmcp1la);
   else
      ChangeMenuImage(IDM_P1LEVEL, hbmcp1lb);

   if (difright == 0)
      ChangeMenuImage(IDM_P2LEVEL, hbmcp2la);
   else
      ChangeMenuImage(IDM_P2LEVEL, hbmcp2lb);

   if (tv == 1)
      ChangeMenuImage(IDM_TVTYPE, hbmctvc);
   else
      ChangeMenuImage(IDM_TVTYPE, hbmctvb);

             ChangeMenuImage(IDM_SELECT,     hbmcslct);
             ChangeMenuImage(IDM_RESET,      hbmcrst);
             ChangeMenuImage(IDM_SETTING,    hbmcset);
             ChangeMenuImage(IDM_GAMEHELP,   hbmccrt);
             ChangeMenuImage(IDM_STELLAHELP, hbmchlp);

            WinQueryWindowRect (hwnd, &rcl);
                   width = rcl.xRight;
                   height = rcl.yTop - infoheight;
                   aptl[0].x = 32;aptl[0].y = 0;
                   aptl[1].x = width-33;aptl[1].y = 0;
                   aptl[2].x = width-33;aptl[2].y = infoheight - 2;
                   GpiSetColor(hpsClient, CLR_WHITE);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[1].x = 32;aptl[1].y = infoheight - 2;
                   aptl[2].x = 32;aptl[2].y = 0;
                   GpiSetColor(hpsClient, CLR_DARKGRAY);
                   GpiPolyLine(hpsClient, 2, &aptl[1]);

                   aptl[0].x = 32;         aptl[0].y = infoheight - 1;
                   aptl[1].x = width - 33; aptl[1].y = infoheight - 1;
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   GpiMove(hpsClient, &aptl[0]);
                   GpiLine(hpsClient, &aptl[1]);

                   GpiSetBackColor(hpsClient, CLR_PALEGRAY);
                   GpiSetColor(hpsClient, CLR_PALEGRAY);
                   ptl.x = 34; ptl.y = fm.lMaxDescender + 1;
                   udrcl.xLeft = 33; udrcl.yBottom = 1;
                   udrcl.xRight = width-34; udrcl.yTop = infoheight-3;

                   aptl[0].x = 33; aptl[0].y = 1;
                   aptl[1].x = width - 34; aptl[1].y = infoheight - 3;
                   GpiMove(hpsClient, &aptl[0]);
                   GpiBox(hpsClient, DRO_FILL, &aptl[1], 0L, 0L);
                   GpiSetColor(hpsClient, CLR_DARKBLUE);

                   rcl.xLeft = 0; rcl.xRight = 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbleft, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

                   WinQueryWindowRect (hwnd, &rcl) ;
                   rcl.xLeft = rcl.xRight - 32;
                   rcl.yBottom = 0; rcl.yTop = 26;
                   WinDrawBitmap (hpsClient, hbright, NULL, (PPOINTL) &rcl,
                                CLR_BACKGROUND, CLR_NEUTRAL, DBM_STRETCH) ;

             return 0;


          case WM_CHAR:
             if (CHARMSG(&msg)->fs & KC_PREVDOWN)
                return 0;

             scancode = CHAR4FROMMP (mp1);

             // handle PAUSE key
             if ((CHARMSG(&msg)->fs & KC_KEYUP) && (CHAR4FROMMP (mp1) == scPause))
             {
                game_paused = (game_paused != 0) ? 0 : 1;
                if (game_paused)
                {
                   sprintf(szTitle, "-=> PAUSED <=-");
                   WinSetCapture( HWND_DESKTOP, 0 );
                   GpiCharStringPosAt(hpsClient, &ptl, &udrcl, CHS_CLIP | CHS_OPAQUE, (LONG) strlen(szTitle), szTitle, NULL);
                   if (StealMouse)
                   {
                      WinSetCapture( HWND_DESKTOP, NULL);
                      WinSetPointer(HWND_DESKTOP,WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE));
                   }
                }
                else
                   if (StealMouse)
                   {
                      WinSetCapture( HWND_DESKTOP, NULL);
                      WinSetPointer(HWND_DESKTOP,WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE));
                   }
             }

             // handle CONTROl key - allows window resize & release of captured mouse
             if (CHARMSG(&msg)->fs & KC_CTRL)
             {
                if ((scancode >= 2) && (scancode <= 10))
                   SizeTheWindow(hwnd, scancode - 1);
                Control = TRUE;
                if (StealMouse)
                {
                   WinSetCapture( HWND_DESKTOP, NULL);
                   WinSetPointer(HWND_DESKTOP,WinQuerySysPointer(HWND_DESKTOP, SPTR_ARROW, FALSE));
                }
             }
             else
             {
                Control = FALSE;
                if (StealMouse)
                {
                   WinSetCapture( HWND_DESKTOP, hwndClient);
                   WinSetPointer(HWND_DESKTOP,NULL);
                   WinSetPointerPos(HWND_DESKTOP, midscreenx, midscreeny);
                }
             }

             // handle user mapped keyboard controls
             if (scancode == scJoystickZeroLeft)
             {
                theEvent.set(Event::JoystickZeroLeft, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickZeroLeft, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickZeroRight)
             {
                theEvent.set(Event::JoystickZeroRight, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickZeroRight, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickZeroUp)
             {
                theEvent.set(Event::JoystickZeroUp, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickZeroUp, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickZeroDown)
             {
                theEvent.set(Event::JoystickZeroDown, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickZeroDown, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickZeroFire)
             {
                theEvent.set(Event::JoystickZeroFire, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickZeroFire, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scBoosterGripZeroTrigger)
             {
                theEvent.set(Event::BoosterGripZeroTrigger, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::BoosterGripZeroTrigger, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickOneLeft)
             {
                theEvent.set(Event::JoystickOneLeft, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickOneLeft, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickOneRight)
             {
                theEvent.set(Event::JoystickOneRight, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickOneRight, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickOneUp)
             {
                theEvent.set(Event::JoystickOneUp, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickOneUp, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickOneDown)
             {
                theEvent.set(Event::JoystickOneDown, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickOneDown, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scJoystickOneFire)
             {
                theEvent.set(Event::JoystickOneFire, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::JoystickOneFire, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scBoosterGripOneTrigger)
             {
                theEvent.set(Event::BoosterGripOneTrigger, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::BoosterGripOneTrigger, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode ==  scQuit)
             {
                theQuitIndicator = TRUE;
                newgame = FALSE;
             }

             if (scancode ==  scSelect)
             {
                theEvent.set(Event::ConsoleSelect, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleSelect, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode ==  scReset)
             {
                theEvent.set(Event::ConsoleReset, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleReset, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode ==  scColor)
             {
                theEvent.set(Event::ConsoleColor, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleColor, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleBlackWhite, 0);
                keyboardEvent.set(Event::ConsoleBlackWhite, 0);
                ChangeMenuImage(IDM_TVTYPE, hbmctvc);
             }

             if (scancode ==  scBnW)
             {
                theEvent.set(Event::ConsoleBlackWhite, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleBlackWhite, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleColor, 0);
                keyboardEvent.set(Event::ConsoleColor, 0);
                ChangeMenuImage(IDM_TVTYPE, hbmctvb);
             }

             if (scancode ==  sc1A) // difficulty selectors work the opposite of what you would expect
             {
                theEvent.set(Event::ConsoleLeftDifficultyB, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleLeftDifficultyB, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleLeftDifficultyA, 0);
                keyboardEvent.set(Event::ConsoleLeftDifficultyA, 0);
                ChangeMenuImage(IDM_P1LEVEL, hbmcp1la);
             }

             if (scancode ==  sc1B)
             {
                theEvent.set(Event::ConsoleLeftDifficultyA, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleLeftDifficultyA, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleLeftDifficultyB, 0);
                keyboardEvent.set(Event::ConsoleLeftDifficultyB, 0);
                ChangeMenuImage(IDM_P1LEVEL, hbmcp1lb);
             }

             if (scancode ==  sc2A)
             {
                theEvent.set(Event::ConsoleRightDifficultyB, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleRightDifficultyB, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleRightDifficultyA, 0);
                keyboardEvent.set(Event::ConsoleRightDifficultyA, 0);
                ChangeMenuImage(IDM_P2LEVEL, hbmcp2la);
             }

             if (scancode ==  sc2B)
             {
                theEvent.set(Event::ConsoleRightDifficultyA, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::ConsoleRightDifficultyA, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                theEvent.set(Event::ConsoleRightDifficultyB, 0);
                keyboardEvent.set(Event::ConsoleRightDifficultyB, 0);
                ChangeMenuImage(IDM_P2LEVEL, hbmcp2lb);
             }

             if (scancode == scKeyboardZero1)
             {
                theEvent.set(Event::KeyboardZero1, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero1, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero2)
             {
                theEvent.set(Event::KeyboardZero2, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero2, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero3)
             {
                theEvent.set(Event::KeyboardZero3, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero3, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero4)
             {
                theEvent.set(Event::KeyboardZero4, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero4, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero5)
             {
                theEvent.set(Event::KeyboardZero5, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero5, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero6)
             {
                theEvent.set(Event::KeyboardZero6, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero6, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }
             if (scancode == scKeyboardZero7)
             {
                theEvent.set(Event::KeyboardZero7, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero7, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero8)
             {
                theEvent.set(Event::KeyboardZero8, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero8, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero9)
             {
                theEvent.set(Event::KeyboardZero9, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero9, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZeroStar)
             {
                theEvent.set(Event::KeyboardZeroStar, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZeroStar, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZero0)
             {
                theEvent.set(Event::KeyboardZero0, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZero0, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardZeroPound)
             {
                theEvent.set(Event::KeyboardZeroPound, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardZeroPound, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne1)
             {
                theEvent.set(Event::KeyboardOne1, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne1, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne2)
             {
                theEvent.set(Event::KeyboardOne2, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne2, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne3)
             {
                theEvent.set(Event::KeyboardOne3, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne3, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne4)
             {
                theEvent.set(Event::KeyboardOne4, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne4, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne5)
             {
                theEvent.set(Event::KeyboardOne5, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne5, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne6)
             {
                theEvent.set(Event::KeyboardOne6, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne6, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne7)
             {
                theEvent.set(Event::KeyboardOne7, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne7, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne8)
             {
                theEvent.set(Event::KeyboardOne8, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne8, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne9)
             {
                theEvent.set(Event::KeyboardOne9, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne9, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOneStar)
             {
                theEvent.set(Event::KeyboardOneStar, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOneStar, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOne0)
             {
                theEvent.set(Event::KeyboardOne0, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOne0, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scKeyboardOnePound)
             {
                theEvent.set(Event::KeyboardOnePound, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
                keyboardEvent.set(Event::KeyboardOnePound, (CHARMSG(&msg)->fs & KC_KEYUP) ? 0 : 1);
             }

             if (scancode == scNewGame)
             {
                theQuitIndicator = TRUE;
                newgame = TRUE;
                if (curplaybuf) memset(curplaybuf,0,buflen);
             }

             return 0;


          case WM_SETWINDOWPARAMS:
               pwprm = (PWNDPARAMS) PVOIDFROMMP (mp1);
               if (pwprm->fsStatus & WPM_TEXT)
                  strcpy(pwprm->pszText, szTitle);
               return MRFROMSHORT(1);

          case WM_ACTIVATE:
               game_paused = (mp1) ? (game_paused & 1) : (game_paused | 2);
               return 0;

          case WM_DESTROY:
             free (pbmi);
             if (hpsMainHPS  != NULLHANDLE)
               {
               GpiSelectPalette (hpsMainHPS, NULLHANDLE);
               };
             if (hpalMain != NULLHANDLE)
               {
               GpiDeletePalette (hpalMain);
               };
             if (hpsMainHPS != NULLHANDLE)  GpiDestroyPS (hpsMainHPS);
             theQuitIndicator = TRUE;
             return 0 ;

          case WM_REALIZEPALETTE:
               // This tells DIVE that the physical palette may have changed.
               DiveSetDestinationPalette (hDive, 0, 256, 0 );
               break;

          case WM_VRNDISABLED:
               DiveSetupBlitter (hDive, 0);
               break;

          case WM_MOUSEMOVE:
               if (StealMouse)
                  if (!game_paused)
                     if (!Control)
                        WinSetPointer(HWND_DESKTOP, 0);
               return 0;

          case WM_VRNENABLED:
               if ( !hpsMainHPS )
                  break;
               hrgn = GpiCreateRegion ( hpsMainHPS, 0L, NULL );
               if ( hrgn )
               {
                  // NOTE: If mp1 is zero, then this was just a move message.
                  // Illustrate the visible region on a WM_VRNENABLE.
                  //
                  WinQueryVisibleRegion ( hwnd, hrgn );
                  rgnCtl.ircStart     = 0;
                  rgnCtl.crc          = 50;
                  rgnCtl.ulDirection  = 1;

                  // Get the all ORed rectangles
                  if ( GpiQueryRegionRects ( hpsMainHPS, hrgn, NULL, &rgnCtl, rcls) )
                  {

                     // Now find the window position and size, relative to parent.
                     WinQueryWindowPos (hwndClient, &swp );

                     // Convert the point to offset from desktop lower left.
                     pointl.x = swp.x;
                     pointl.y = swp.y;
                     WinMapWindowPoints ( hwndFrame, HWND_DESKTOP, &pointl, 1 );

                     // Tell DIVE about the new settings.
                     SetupBlitter.ulStructLen = sizeof ( SETUP_BLITTER );
                     SetupBlitter.fccSrcColorFormat = FOURCC_LUT8;
                     SetupBlitter.ulSrcWidth   = 160;
                     SetupBlitter.ulSrcHeight  = scrHEIGHT + ViewWave;
                     SetupBlitter.ulSrcPosX    = 0;
                     SetupBlitter.ulSrcPosY    = 0;
                     SetupBlitter.fInvert      = FALSE;
                     SetupBlitter.ulDitherType = 1;

                     SetupBlitter.fccDstColorFormat = FOURCC_SCRN;
                     SetupBlitter.ulDstWidth        = swp.cx;
                     SetupBlitter.ulDstHeight       = swp.cy - infoheight;
                     SetupBlitter.lDstPosX          = 0;
                     SetupBlitter.lDstPosY          = infoheight;
                     SetupBlitter.lScreenPosX       = pointl.x;
                     SetupBlitter.lScreenPosY       = pointl.y;
                     SetupBlitter.ulNumDstRects     = rgnCtl.crcReturned;
                     SetupBlitter.pVisDstRects      = rcls;
                     DiveSetupBlitter (hDive, &SetupBlitter);
                  }
                  else
                     DiveSetupBlitter (hDive, 0);

                  GpiDestroyRegion (hpsMainHPS, hrgn);
               }
               break;

     }
     return WinDefWindowProc (hwnd, msg, mp1, mp2) ;
}



MRESULT EXPENTRY DlgProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
   char dragname[CCHMAXPATH];
   STARTDATA   sd;
   PID         procID;
   ULONG       sessID;
   APIRET      rc;
   APIRET      arReturn;
   FILESTATUS3 fsStatus;

   switch(msg)
   {
      case WM_INITDLG:   // initialize all the sliders and numeric displays
         WinCheckButton(hwnd, DB_P0_MOUSE + db_paddle0, 1);
         WinCheckButton(hwnd, DB_P1_MOUSE + db_paddle1, 1);
         WinCheckButton(hwnd, DB_P2_MOUSE + db_paddle2, 1);
         WinCheckButton(hwnd, DB_P3_MOUSE + db_paddle3, 1);

         switch(db_frequency)
         {
            case  8000: WinCheckButton(hwnd, DB_AF_8, 1);
                        break;
            case 11025: WinCheckButton(hwnd, DB_AF_11, 1);
                        break;
            case 22050: WinCheckButton(hwnd, DB_AF_22, 1);
                        break;
            default:
            case 31400: WinCheckButton(hwnd, DB_AF_31, 1);
                        break;
            case 33075: WinCheckButton(hwnd, DB_AF_33, 1);
                        break;
            case 44100: WinCheckButton(hwnd, DB_AF_44, 1);
                        break;
         }

         WinSetDlgItemShort(hwnd, DB_BS_BT, db_buffer, TRUE);                    // init buffer size text
         WinSendDlgItemMsg(hwnd, DB_BS_B, SLM_SETSLIDERINFO,                     // init buffer size slider position
              MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((db_buffer - 256) / 32) );

         WinSendDlgItemMsg(hwnd, DB_OSC, BM_SETCHECK, MPFROMSHORT(db_osc), NULL);
         WinSendDlgItemMsg(hwnd, DB_HEIGHT, BM_SETCHECK, MPFROMSHORT(db_height), NULL);
         WinSendDlgItemMsg(hwnd, DB_CART_NOTE, BM_SETCHECK, MPFROMSHORT(db_note), NULL);
         WinSendDlgItemMsg(hwnd, DB_AV_ON, BM_SETCHECK, MPFROMSHORT(db_volume), NULL);

         WinSetDlgItemShort(hwnd, DB_FPS_MIN_T, fps[db_frt][db_min] + .5, TRUE); // init min text
         WinSendDlgItemMsg(hwnd, DB_FPS_MIN, SLM_SETSLIDERINFO,                  // init min slider position
              MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_min) * 5) );

         WinSetDlgItemShort(hwnd, DB_FPS_MAX_T, fps[db_frt][db_max] + .5, TRUE); // init min text
         WinSendDlgItemMsg(hwnd, DB_FPS_MAX, SLM_SETSLIDERINFO,                  // init min slider position
              MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_max) * 5) );

         WinSetDlgItemShort(hwnd, DB_FPS_INIT_T, fps[db_frt][db_init] + .5, TRUE);       // init min text
         WinSendDlgItemMsg(hwnd, DB_FPS_INIT, SLM_SETSLIDERINFO,                   // init min slider position
              MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_init) * 5) );

         WinSendDlgItemMsg(hwnd, DB_IWS, SPBM_SETLIMITS, MPFROMLONG(9), MPFROMLONG(1));
         WinSendDlgItemMsg(hwnd, DB_IWS, SPBM_SETCURRENTVALUE, MPFROMLONG(db_size), NULL);

         return 0;

      case WM_COMMAND:
         switch(SHORT1FROMMP(mp1))
         {
            case DB_J_REC: JoystickInit(1,StellaIni);
               WinMessageBox( HWND_DESKTOP, HWND_DESKTOP,
                  "The Joystick calibration information has been reset.  Once back in Stella/2 you will need to move your joystick to all four corners to recalibrate!",
                  "Joysticks Reset" , 0, MB_OK | MB_INFORMATION );
               return 0;

            case DB_P_DEF:
               WinCheckButton(hwnd, DB_P0_MOUSE + 0, 1);
               WinCheckButton(hwnd, DB_P1_MOUSE + 1, 1);
               WinCheckButton(hwnd, DB_P2_MOUSE + 2, 1);
               WinCheckButton(hwnd, DB_P3_MOUSE + 3, 1);
               db_paddle0=0;
               db_paddle1=1;
               db_paddle2=2;
               db_paddle3=3;
               return 0;

            case DB_AF_DFLT: db_volume = 1;
               db_frequency = 31400;
               db_buffer = 1024;
               db_osc = 0;
               db_volume = 1;
               WinCheckButton(hwnd, DB_AF_31, 1);
               WinSetDlgItemShort(hwnd, DB_BS_BT, db_buffer, TRUE);                    // init buffer size text
               WinSendDlgItemMsg(hwnd, DB_BS_B, SLM_SETSLIDERINFO,                     // init buffer size slider position
               MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((db_buffer - 256) / 32) );
               WinSendDlgItemMsg(hwnd, DB_OSC, BM_SETCHECK, MPFROMSHORT(db_osc), NULL);
               WinSendDlgItemMsg(hwnd, DB_AV_ON, BM_SETCHECK, MPFROMSHORT(db_volume), NULL);
               return 0;

            case DB_HELP: arReturn = DosQueryPathInfo(StellaHelp, FIL_STANDARD, &fsStatus, sizeof(fsStatus));
               if (arReturn != 0)
                  WinMessageBox( HWND_DESKTOP, HWND_DESKTOP, StellaHelp, (PSZ)"File is missing!", 0, MB_OK | MB_INFORMATION );
               else
               {
                  sprintf(dragname, "\"%s\" \"settings dialog\"", StellaHelp);
                  JoystickOff();
                  procID = 0;
                  sessID = 0;
                  memset(&sd, 0, sizeof(STARTDATA));
                  sd.PgmName = "VIEW.EXE";
                  sd.PgmInputs = dragname; // Master GearHelp;
                  sd.SessionType = SSF_TYPE_PM;
                  sd.Length = sizeof(STARTDATA);
                  sd.Related = SSF_RELATED_INDEPENDENT;
                  sd.FgBg = SSF_FGBG_FORE;
                  sd.TraceOpt = SSF_TRACEOPT_NONE;
                  sd.TermQ = 0;
                  sd.Environment = NULL;
                  sd.InheritOpt = SSF_INHERTOPT_PARENT;
                  sd.PgmControl = SSF_CONTROL_VISIBLE | SSF_CONTROL_MAXIMIZE;
                  sd.InitXPos = 10;
                  sd.InitYPos = 10;
                  sd.InitXSize = 400;
                  sd.InitYSize = 600;
                  sd.Reserved = 0;
                  sd.ObjectBuffer = NULL;
                  sd.ObjectBuffLen = 0;
                  rc = DosStartSession(&sd, &sessID, &procID);
                  DosSleep(5000);
                  JoystickOn();
               }
               return 0;

            case DB_CAN:
               db_OK = FALSE;
               WinDismissDlg(hwnd, TRUE);
               return 0;

            case DB_OK:
               db_OK = TRUE;
               db_osc = (int) WinSendDlgItemMsg(hwnd, DB_OSC, BM_QUERYCHECK, NULL, NULL);
               db_height = (int) WinSendDlgItemMsg(hwnd, DB_HEIGHT, BM_QUERYCHECK, NULL, NULL);
               db_note = (int) WinSendDlgItemMsg(hwnd, DB_CART_NOTE, BM_QUERYCHECK, NULL, NULL);
               db_volume = (int) WinSendDlgItemMsg(hwnd, DB_AV_ON, BM_QUERYCHECK, NULL, NULL);
               WinSendDlgItemMsg(hwnd, DB_IWS, SPBM_QUERYVALUE, (PVOID) &db_size,  MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID));
//               WinSendDlgItemMsg(hwnd, DB_IWS_GG, SPBM_QUERYVALUE, (PVOID) &db_sizegg,  MPFROM2SHORT( 0, SPBQ_UPDATEIFVALID));
               WinDismissDlg(hwnd, TRUE);
               return 0;
         }

      case WM_CONTROL:
         switch(SHORT1FROMMP(mp1))
         {
            case DB_P0_MOUSE: case DB_P0_JOY0: case DB_P0_JOY1:
            case DB_P0_NONE: case DB_P0_REAL:
               db_paddle0 = SHORT1FROMMP(mp1) - DB_P0_MOUSE;
               return 0;

            case DB_P1_MOUSE: case DB_P1_JOY0: case DB_P1_JOY1:
            case DB_P1_NONE: case DB_P1_REAL:
               db_paddle1 = SHORT1FROMMP(mp1) - DB_P1_MOUSE;
               return 0;

            case DB_P2_MOUSE: case DB_P2_JOY0: case DB_P2_JOY1:
            case DB_P2_NONE: case DB_P2_REAL:
               db_paddle2 = SHORT1FROMMP(mp1) - DB_P2_MOUSE;
               return 0;

            case DB_P3_MOUSE: case DB_P3_JOY0: case DB_P3_JOY1:
            case DB_P3_NONE: case DB_P3_REAL:
               db_paddle3 = SHORT1FROMMP(mp1) - DB_P3_MOUSE;
               return 0;

            case DB_AV_ON:
               db_volume = 1;
               return 0;

            case DB_AF_8:
               db_frequency =  8000;
               return 0;

            case DB_AF_11:
               db_frequency =  11025;
               return 0;

            case DB_AF_22:
               db_frequency =  22050;
               return 0;

            case DB_AF_31:
               db_frequency =  31400;
               return 0;

            case DB_AF_33:
               db_frequency =  33075;
               return 0;

            case DB_AF_44:
               db_frequency =  44100;
               return 0;

            case DB_BS_B:
               if ((SHORT2FROMMP(mp1) == SLN_CHANGE) || (SHORT2FROMMP(mp1) == SLN_SLIDERTRACK))
               {
                  db_buffer = (int) mp2 * 32 + 256;
                  WinSetDlgItemShort(hwnd, DB_BS_BT, db_buffer, TRUE);
               }
               return 0;

            case DB_FPS_MIN:
               if ((SHORT2FROMMP(mp1) == SLN_CHANGE) || (SHORT2FROMMP(mp1) == SLN_SLIDERTRACK))
               {
                  db_min = 15 - (int) mp2 / 5;
                  WinSetDlgItemShort(hwnd, DB_FPS_MIN_T, fps[db_frt][db_min] + .5, TRUE);
                  if (db_min < db_max)
                  {
                     db_max = db_min;
                     WinSetDlgItemShort(hwnd, DB_FPS_MAX_T, fps[db_frt][db_max] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_MAX, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_max) * 5) );
                  }
                  if (db_min < db_init)
                  {
                     db_init = db_min;
                     WinSetDlgItemShort(hwnd, DB_FPS_INIT_T, fps[db_frt][db_init] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_INIT, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_init) * 5) );
                  }
               }
               return 0;

            case DB_FPS_MAX:
               if ((SHORT2FROMMP(mp1) == SLN_CHANGE) || (SHORT2FROMMP(mp1) == SLN_SLIDERTRACK))
               {
                  db_max = 15 - (int) mp2 / 5;
                  WinSetDlgItemShort(hwnd, DB_FPS_MAX_T, fps[db_frt][db_max] + .5, TRUE);
                  if (db_max > db_min)
                  {
                     db_min = db_max;
                     WinSetDlgItemShort(hwnd, DB_FPS_MIN_T, fps[db_frt][db_min] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_MIN, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_min) * 5) );
                  }
                  if (db_max > db_init)
                  {
                     db_init = db_max;
                     WinSetDlgItemShort(hwnd, DB_FPS_INIT_T, fps[db_frt][db_init] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_INIT, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_init) * 5) );
                  }
               }
               return 0;

            case DB_FPS_INIT:
               if ((SHORT2FROMMP(mp1) == SLN_CHANGE) || (SHORT2FROMMP(mp1) == SLN_SLIDERTRACK))
               {
                  db_init = 15 - (int) mp2 / 5;
                  WinSetDlgItemShort(hwnd, DB_FPS_INIT_T, fps[db_frt][db_init] + .5, TRUE);
                  if (db_max > db_init)
                  {
                     db_max = db_init;
                     WinSetDlgItemShort(hwnd, DB_FPS_MAX_T, fps[db_frt][db_max] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_MAX, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_max) * 5) );
                  }
                  if (db_min < db_init)
                  {
                     db_min = db_init;
                     WinSetDlgItemShort(hwnd, DB_FPS_MIN_T, fps[db_frt][db_min] + .5, TRUE);       // init min text
                     WinSendDlgItemMsg(hwnd, DB_FPS_MIN, SLM_SETSLIDERINFO,                   // init min slider position
                        MPFROM2SHORT( SMA_SLIDERARMPOSITION, SMA_RANGEVALUE), MPFROMLONG((15 - db_min) * 5) );
                  }
               }
               return 0;
         }
      return 0;
   }
   return WinDefDlgProc(hwnd, msg, mp1, mp2);
}

