.**********************************************************
.*
.* IPF for Stella/2
.*
.**********************************************************
:userdoc.
:title.Stella/2 Ver 1.1 released November 3, 2000
.*
.**********************************************************
.*
:h1.A Brief History of the Atari 2600
:p.
:artwork align=center name='atari.bmp'.
In the early 1970's, video arcade games gained commercial success for the first time. The American
public was introduced to Pong, Tank, and other interactive video games which populated amusement
parks, bars, and arcades. The games were successful enough to create
interest for home versions, so in 1975 Atari released Home
Pong and it was a smash hit. Other companies such as Magnavox
and Coleco followed suit and released their own dedicated console
games. Then in 1976, Fairchild Camera and Instrument introduced
the Channel F system, the first cartridge based home video game
system. The industry recognized that cartridge systems were the future
of video gaming, and began development in that direction. In
January 1977, RCA released the Studio II, another cartridge based
system, although it only projected in black and white and seemed to
be focused on educational titles. Then, in October 1977, Atari released
the Atari VCS (Video Computer System) with an initial offering of nine games. This system, later
renamed the Atari 2600, took the industry by storm and dominated the marketplace for years to come.
:p.
:artwork align=right name='chuck.bmp'.
Because of oversupply, the Christmas season of 1977 was very rough on the video game industry, and
the Atari 2600 was the only system that managed to emerge unscathed. Atari enjoyed strong sales in
1978 and a fantastic holiday season, as Atari released more games such as Outlaw, Spacewar, and Breakout.
Internally however, Atari was at odds. Nolan Bushnell, the inventor of pong and founder of Atari,
wound up leaving the company and purchased Pizza Time Theater, which later
became the successful Chuck E. Cheese! In 1979 Atari continued their trend and
released 12 more games which met with continued success. However, Atari was
now facing some stiffer competition from the Mattel Intellivision and the Magnavox
Odyssey2.
:p.
:artwork align=center name='invaders.bmp'.
Atari needed a mega-hit in 1980 in order to squash the competition, and they
found it in the home version of a game from Japan called Space Invaders. It was
so popular that people were buying the
Atari 2600 just so they could play Space
Invaders at home. Following that, Atari released
Adventure, which was the first video
game to contain an Easter Egg - placing an
object in a certain area revealed the
programmer's name, Warren Robinett.
1980 was important for another reason - the creation of the first
ever third party software producer, Activision. The company was
formed by four Atari employees who were unsatisfied with the working conditions at the company.
They released four games initially: Dragster, Fishing Derby, Checkers and Boxing. The games were
very well received by the public, and revealed that the Atari 2600 was capable of better games than Atari
themselves had been producing. Atari tried to prevent Activision from selling games, but they failed and
Activision grossed $70 million that year.

:p.
By 1981, the video game industry was basically a horse race between the 2600 and the Intellivision.
While the Intellivision was technologically superior in some respects, the 2600 continued to lead in
sales. Atari released the home version of Asteroids, which was a huge success. Inspired by the success
of Activision, another software development group called Imagic was formed. They would not release
any games until 1982 however. Another company, Games by Apollo, was formed in Texas and released
several games that year.
:p.
:artwork name='pacman.bmp'.
Coleco entered the market in 1982 with the release of the graphically superior Colecovision. To combat
this new system, Atari produced the 5200, a technologically comparable system. The 2600 dropped $100
in price in order to remain competitive. Then a company called Arcadia
released a peripheral called the Supercharger which played
games in an audio cassette medium. This allowed for multiple loads
and expanded the 2600's capabilities. Atari released Pac-Man and
E.T. that year, two incredibly
hyped games which were critical
flops. Although Pac-Man sold
many copies, it was considered
to be a poor translation of the
arcade hit. However, there were
many fantastic games produced
for the 2600 during this period,
and it was still selling strong.
:artwork align=right name='starpath.bmp'.
:p.
Ever since the inception of Activision, Atari had been fighting to
keep third parties from producing cartridges which they felt were
stealing profits from them. Finally the issue was settled when Atari agreed to allow third party manufacturing
in exchange for a royalty. Suddenly software companies began popping up all over, and 1982 saw
releases from companies like Venturevision, Spectravision, Telesys, CBS, 20th Century Fox, US
Games, M Network, Tigervision, Data Age, Imagic and Coleco. There was even a company that released
a line of X-Rated games for the 2600 called Mystique. The year was financially successful for
Atari, however there seemed to be a glut of software. Although there were many quality titles still produced,
there was an increasing number of rushed games as manufacturers attempted to cash in on the
craze.
:p.
More companies jumped on the band wagon in 1983. Zimag, Ultravision, Amiga, and others were also
producing games and peripherals. It seemed as if there was just too much product to meet the demand,
and as it turned out there was. By the end of the year, companies began folding. US Games, Data Age,
Games by Apollo, Telesys and others all closed their doors from poor sales. A video game crash was occurring,
and all companies were taking it on the chin.
:p.
1984 was a much more subdued year for the Atari 2600, and the price of the system had now dropped to
$40-$50. Many were saying that the video game industry was dead. However, Atari surprised everyone
by announcing the release of the 7800, and also promising more 2600 games with improved graphics
and sound. Unfortunately, neither of these things happened in 1984 because Atari sold their home video
game division to Jack Tramiel who believed that home computers would replace video game systems.
No further mention of the 2600 or 7800 was made that year, and it appeared that they might be dead.
:p.
1985 was another very quiet year for Atari and video games in general, and only a few games were released
for the 2600. Activision produced Cosmic Commuter and Ghostbusters, but with little fanfare or
marketing, these games did not sell well. However, because of the huge game library and cheap price,
Atari still sold over a million 2600 consoles in 1985.
:p.
There were very few plans for home video game systems by any company in 1986, since the market appeared
to be dead. Then, to most people's surprise, Nintendo brought the NES to America and it was a
smash hit, proving that video games still had a place in the US. Atari decided that maybe it would be a
good idea to release the 7800 units it had in storage, and produce some more 2600 games. The 7800 was
released with only 3 games initially available, although it was compatible with the 2600 library. They
also redesigned the 2600 as the 2600 Jr., a machine with the same abilities, but a new look and marketing
campaign. It was sold for less than $50.
:p.
:artwork name='jrpacman.bmp'.
Video games were once again selling phenomenally in 1987. Atari released several new titles, including
Jr. Pac-Man, and also licensed a number of games from other companies
such as Donkey Kong and Q*Bert. These new titles sold for
$10-$15. Interestingly, a number of titles began appearing again
from third part companies such as Epyx, Froggo, and Exus. It
seemed that the 2600 was not dead yet! In 1988, Atari rehired Nolan
Bushnell and announced a number of new titles, including Secret
Quest, a game written by
Mr. Bushnell himself. Atari
continued to manufacture these games even until 1989. However, it
was apparent that the 2600, after its introduction over a decade ago,
was finally at the end of its run. Although it was still produced and
marketed outside of the US, the Atari 2600 finished its run in
America. No other console has had such a long history or sold as
many systems in the U.S.
:artwork align=right name='secret.bmp'.
:p.
Today, the 2600 still has a large number of fans who remember the countless games played over the
years, and the years to come. There are even games being produced by hobbyists, some of them quite
professionally, being released on newly burnt cartridges with labels and manuals. And the recent trend in
retrogaming has brought many more video game fans to rediscover the 2600, and it continues to live on
22 years after its release!
:p.
Alexander Bilstein
.br
February 1999
.*
.**********************************************************
.*
:h1.About Stella/2
:p.
Stella is a portable emulator of the old Atari 2600 video game console,
written in C++ by Bradford Mott.  You can play most Atari 2600 games with it.
The latest news, code and binaries for Stella can be found at the Stella Homepage&colon.
.br
:hp4.http&colon.//www4.ncsu.edu/~bwmott/www/2600/:ehp4.
:p.
Darrell Spice, Jr. has ported it to run as a native OS/2 application.
The OS/2 version of Stella can be found at the Stella Homepage, and at the SpiceWare Homepage(along with other emulators for OS/2) at&colon.
.br
:hp4.http&colon.//home.houston.rr.com/spiceware/stella.html:ehp4.
:p.
If you are having problems with Stella please visit either home page and
make sure you're running the lastest release before sending mail. OS/2 version
comments should be mailed to Darrell at :hp4.dspice@houston.rr.com:ehp4..
.*
.**********************************************************
.*
:h1.What's New
:p.
New features in version 1.1 of Stella/2.
:ul.
:LI.Migrated OS/2 source to current core release
:ul compact.
:li.support real Atari 2600 paddles using a special
:link reftype=hd viewport dependent res=400.
Real Paddle Adaptor
:elink.
:li.Greatly improved Supercharger single-load and multi-load game support
:li.Improved TIA emulation to support the RESPx multi-sprite trick
:li.Improved timer emulation (6532 PIA)
:li.Improved CPU emulation (6502)
:li.Supports Robot Tank and Decathlon
:li.Supports Joystick, Keyboard, Booster Grip, and Indy 500 Driving controllers
:li.Preliminary support for Chris Wilkson's Megacart bank-switching scheme
:li.Contains properties for over 1300 ROMs
:li.Optimizations to improve speed
:li.And much more...
:eul.
:li.improved throttle routines for faster systems
:li.added PAL color palette and frame rates
:li.new game controller status (which controller needed for current cartridge)
:li.settings dialogs
:li.keyboard controls are now
:link reftype=hd viewport dependent res=402.
user definable
:elink.
:li.
:link reftype=hd viewport dependent res=401.
Keyboard
:elink.
controls have changed
:li.And much more...
:eul.
.*
.**********************************************************
.*
:h1.Installation
:p.
To install the OS/2 version of Stella, just unzip the Stella archive into your OS/2 games directory.
.*
.**********************************************************
.*
:h1.Running Stella/2
:p.
Run Stella as you would any other program.
:p.
After starting Stella, a title screen will show for about 5 seconds.  Next a file open dialog will be displayed so that a cartridge can be selected for
play.  Cartridges are located in the ROMS directory. Install any additional cartridge images you wish here.
:p.
Stella may also be started by dropping a cartridge onto it.  In this case, the file open dialog will not appear.
.*
.**********************************************************
.*
:h1.ROM Images
:p.
In order to play an Atari 2600 game you have to have a ROM image of the
game.  A ROM image is a file that contains the data off the game cartridge
or cassette.
:p.
Cartridge images for Elk Attack, Okie Dokei, This Planet Sucks, Oystron and
TEST are included with the Stella distribution. Special thanks to
Mark R. Hahn - author of :hp1.Elk Attack:ehp1.,
Bob Colbert - author of :hp1.Okie Dokie:ehp1.,
Greg Troutman - author of :hp1.This Planet Sucks:ehp1.,
and Piero Cavina - author of :hp1.Oystron:ehp1.
for allowing their software to be included in the Stella distribution.

:h2.General
:p.
Most games for the Atari 2600, like many game systems, were stored on
cartridges.  These cartridges usually contained a single ROM chip (Read
Only Memory) which had the program for the game stored on it.  When you
plugged the cartridge into the 2600 it allowed the 2600's microprocessor,
a 6507 which is very similar to a 6502, to execute the program stored
on the cartridge.
:p.
Just like a cartridge had to be plugged into the 2600 you also have to
supply Stella with a copy of the cartridge you want to play.  This is done
by having a ROM image (.BIN file) of the cartridge.  ROM images are files
which contain the actual data off the cartridge (basically it contains
6507 machine code).  There are several ways to get a ROM image:
:ol.
:li.It's possible to build a device that plugs into the printer port
of a PC and reads the data off the cartridge (See the Stella home
page for more information)
:li.Purchase any of the Activision Atari 2600 Action Packs and use the
ROM images (.BIN files) from it
:li.Search around the net and find some ROM images (.BIN files) to download
:eol.
:hp8.:warning.
It is illegal to have ROM images of games that you do not
actually own (i.e. you don't own the cartridge and you
didn't buy it from Activision) or were not released to the public such
as :hp1.Elk Attack:ehp1. and :hp1.Okie Dokie:ehp1..
:ewarning.:ehp8.
:p.
In addition to the ROM image you may need to supply some properties for
the game.  These properties inform Stella of the "best" settings for a
game.  When Stella doesn't have properties for a game it tries to guess
the settings and uses defaults for settings it can't guess.  For most
games you will NOT need to add properties to Stella since it contains
setting for a lot of games and can guess the settings for most of the
others, however, for best results you may decide you want to specify the
properties yourself.  If you do you should read the
:link reftype=hd viewport dependent res=100.
Adding Properties
:elink.
section of this guide.

:h2.Supercharger
:p.
Supercharger games were not stored on cartridges instead they were
stored on cassette tapes. The Supercharger, which plugged into the
Atari 2600's cartridge slot, loaded games into it's 6K of RAM using
a tape player.  The Supercharger also supported multiloading which
allowed games to be broken into several 6K pieces and loaded at
different times.  This was useful for long games that had distinct
parts (i.e. role playing type games).
:p.
Most Supercharger ROM images are stored as an 8448 byte file.  However,
ROM images of multiload games are stored as a set of 8448 byte files.
The names of these files have a two character sequence number in them
which indicate what load they are (the sequence always starts at zero
but then skips a few numbers and then increments by one).
:p.
Stella supports multiload games, however, the set of ROM image files
has to be combined into a single large ROM image file.  To create
a multiload ROM image file for Stella under OS/2 do the following in
an OS/2 command prompt window:
.br
  [D&colon.\] copy survivl0.bin + survivl6.bin + survivl7.bin survivl.bin
:p.
Then you can play the game with Stella using the survivl.bin file.
Stella has properties builtin for most of the Supercharger games,
however, if you're developing your own Supercharger game you might
need to add some properties to Stella. See the
:link reftype=hd viewport dependent res=100.
Adding Properties
:elink.
section of this guide for more information.
:p.
:note.It is VERY important that the "Emulation.CPU" property be set
to "High" for Supercharger games.  If it isn't the game will not run
correctly.  Stella automatically sets this property if it sees a ROM
image who's size is a multiple of 8448.
.*
.**********************************************************
.*
:h2.Known Problems
:p.
This section contains information about known problems with some cartridges:
:ul.
:li.:hp4.Defender II:ehp4.
:ul.
:li.This cartridge is really an F8SC cartridge, 8K with 128 bytes of RAM, not an F6SC cartridge.  There is a 16K image of this cartridge floating around that has the right code in it, however, it's the second 8K that's needed.
:li.You can fix this in a :hp4.DOS:ehp4. window by typing what's :hp8.highlighted:ehp8. below:
:xmp.
:hp8.DEBUG DEFENDR2.BIN:ehp8.
-:hp8.RCX:ehp8.
CX 4000
&colon. :hp8.2000:ehp8.
-:hp8.W2100:ehp8.
Writing 02000 bytes
-:hp8.Q:ehp8.
(provided by plord@mail.pacificnet.net)
:exmp.
:eul.
:li.:hp4.Stargate:ehp4.
:ul.
:li.Same as Defender II above
:eul.
:li.:hp4.Sentinal:ehp4.
:ul.
:li.The Lightgun controller is not supported in Stella at this time.
:eul.
:li.:hp4.Bionic Breakout:ehp4.
:ul.
:li.The MindLink controller is not supported in Stella at this time.
:eul.
:eul.
.*
.**********************************************************
.*
:h1 res=100.Stella Properties
:p.
The property file, :hp4.STELLA.PRO:ehp4. consists of some number of blocks.
Each block in the file contains the properties for a single game.
For example the general format of a property file is:
:xmp.
 ; Comments
 "Cartridge.Name" "Value"
 "Property""Value"
 ""
 ; Comments
 "Cartridge.Name" "Value"
 "Property""Value"
 ""
 . . .
 ; Comments
 "Cartridge.Name" "Value"
 "Property""Value"
 ""
:exmp.
 Every block in the property file must have a unique value for the Cartridge.Name property.

.*
.**********************************************************
.*
:h2.Property Types
:p.
Each block in a property file consists of a set of properties for a single game.
Stella supports the properties described below.
:table cols='20 57'.
:row.
:c.Property
:c.Purpose and :hp4.Allowed Values:ehp4.
:row.
:c.Cartridge.Filename
:c.This property indicates the name of the file containing the ROM image. In
general this property is not needed, however, if present Stella uses it while attempting to match a
game with its block of properties. If the value of the property matches the filename of the ROM
image then Stella uses that block of properties for the game.
:row.
:c.Cartridge.MD5
:c.This property indicates the MD5 checksum of the ROM image as a string of hexadecimal
digits. Stella uses this property while attempting to match a game with its block of properties.
If the value of the property matches the MD5 checksum of the ROM image then Stella
uses that block of properties for the game. You can use the GNU md5sum program, which is
included with most Linux distributions, to calculate the MD5 checksum of a ROM image.
:row.
:c.Cartridge.Manufacturer
:c.This property indicates the game's manufacturer. Currently this property
is not being used, however, future versions of Stella will probably allow the user to view this
information.
:row.
:c.Cartridge.ModelNo
:c.This property indicates the manufacturer's model number for the game. Currently
this property is not being used, however, future versions of Stella will probably allow the
user to view this information.
:row.
:c.Cartridge.Name
:c.This property indicates the actual name of the game. It is very important that this
property's value be unique from all other cartridge names in the property file.
:row.
:c.Cartridge.Note
:c.This property contains any special notes about playing the game. This information will
scroll across the status line when the game is first loaded.
:row.
:c.Cartridge.Type
:c.This property indicates the bank-switching type for the game. The value of this
property must be: :hp4.Auto-detect:ehp4., :hp4.2K:ehp4., :hp4.3F:ehp4., :hp4.4K:ehp4., :hp4.AR:ehp4.,
:hp4.E0:ehp4., :hp4.E7:ehp4., :hp4.F4SC:ehp4., :hp4.F6:ehp4., :hp4.F6SC:ehp4., :hp4.F8:ehp4., :hp4.F8SC:ehp4., :hp4.FASC:ehp4., or
:hp4.FE:ehp4.. For more information about bank-switching see Kevin Horton's 2600 bank-switching document.
:row.
:c.Console.LeftDifficulty
:c.This property indicates the default difficulty setting for the left player.
The value of this property must be :hp4.A:ehp4. or :hp4.B:ehp4..
:row.
:c.Console.RightDifficulty
:c.This property indicates the default difficulty setting for the right
player. The value of this property must be :hp4.A:ehp4. or :hp4.B:ehp4..
:row.
:c.Console.TelevisionType
:c.This property indicates the default television setting for the game.
The value of this property must be :hp4.Color:ehp4. or :hp4.BlankAndWhite:ehp4..
:row.
:c.Controller.Left
:c.This property indicates what type of controller the left player uses. The value of
 this property must be :hp4.Booster-Grip:ehp4., :hp4.Driving:ehp4., :hp4.Keyboard:ehp4.,
:hp4.Paddles:ehp4., :hp4.Joystick:ehp4., :hp4.Mindlink:ehp4. or :hp4.Lightgun:ehp4..
:row.
:c.Controller.Right
:c.This property indicates what type of controller the right player uses. The value
of this property must be :hp4.Booster-Grip:ehp4., :hp4.Driving:ehp4., :hp4.Keyboard:ehp4.,
:hp4.Paddles:ehp4., :hp4.Joystick:ehp4., :hp4.Mindlink:ehp4. or :hp4.Lightgun:ehp4..
:row.
:c.Display.Format
:c.This property indicates the television format the game was designed for. The
value of this property must be:hp4. NTSC:ehp4. or :hp4.PAL:ehp4..  This property
will set the frame rate and color palette.
:row.
:c.Display.XStart
:c.This property indicates the horizontal location to start displaying pixels at on a
scan-line. The value of this property must be n such that :hp4.0 <= n <= 80:ehp4. and :hp4.n is divisible by 4:ehp4..
:row.
:c.Display.Width
:c.This property indicates the number of pixels to display per scan-line. The value of
this property must be n such that :hp4.80 <= n <= 160:ehp4. and :hp4.n is divisible by 4:ehp4..
:row.
:c.Display.YStart
:c.This property indicates the scan-line to start displaying at. The value of this property
must be n such that :hp4.0 <= n <= 64:ehp4..
:row.
:c.Display.Height
:c.This property indicates the number of scan-lines to display. The value of this
property must be n such that :hp4.100 <= n <= 256:ehp4..
:row.
:c.Emulation.CPU
:c.This property indicates the CPU emulation quality. The value of this property must
be :hp4.High:ehp4. or :hp4.Low:ehp4..
:row.
:c.Emulation.HmoveBlanks
:c.This property indicates whether the TIA HMOVE blank bug should be
emulated or not. The value of this property must be :hp4.Yes:ehp4. or :hp4.No:ehp4..
:etable.

:h2.Property Defaults
:p.If no entry is found for the cartridge, the following property values will be used.
:ul compact.
:li.Cartridge.Filename = blank
:li.Cartridge.MD5 = blank
:li.Cartridge.Manufacturer = blank
:li.Cartridge.ModelNo = blank
:li.Cartridge.Name = Untitled
:li.Cartridge.Note = blank
:li.Cartridge.Rarity = blank
:li.Cartridge.Type = Auto-detect
:li.Console.LeftDifficulty = B
:li.Console.RightDifficulty = B
:li.Console.TelevisionType = Color
:li.Controller.Left = Joystick
:li.Controller.Right = Joystick
:li.Display.Format = NTSC
:li.Display.XStart = 0
:li.Display.Width = 160
:li.Display.YStart = 38
:li.Display.Height = 210
:li.Emulation.CPU = Auto-detect
:li.Emulation.HmoveBlanks = Yes
:eul.
.*
.**********************************************************
.*
:h1.Menu Bar
:p.
Left six buttons correspond to the controls on the original console.  Right
three are OS/2 Stella support options.  If the Stella window is expanded a width
of 640 or wider, larger, more detailed buttons will replace the current buttons.
:p.
:artwork align=center name='stella.bmp'.
:artlink.
:link reftype=hd viewport dependent res=211 x=278 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=210 x=245 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=209 x=212 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=205 x=175 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=204 x=142 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=203 x=109 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=202 x=72 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=201 x=39 y=244 cx=29 cy=29.
:link reftype=hd viewport dependent res=200 x=6 y=244 cx=29 cy=29.
:eartlink.
:p.
Select the buttons to view what they do.
:h2 res=200.New Game(Power)
:p.
:artwork name='sng.bmp' runin. Default Size
.br
:artwork name='mng.bmp' runin. Large Size
:p.
Brings up cartridge selection dialog
:Note. Games may also be drag and dropped onto Stella
:h2 res=201.TV Mode
:p.
:artwork name='stvc.bmp' runin. Default Size - Color Mode
.br
:artwork name='stvbw.bmp' runin. Default Size - B&amp.W Mode
.br
:artwork name='mtvc.bmp' runin. Large Size - Color Mode
.br
:artwork name='mtvbw.bmp' runin. Large Size - B&amp.W Mode
:p.
Toggles between color and B&amp.W mode.
:Note. B&amp.W mode depends on cartridge support.

:h2 res=202.Player 1 Difficulty
:p.
:artwork name='sp1la.bmp' runin. Default Size - Player 1 Level A
:p.
:artwork name='sp1lb.bmp' runin. Default Size - Player 1 Level B
:p.
:artwork name='mp1la.bmp' runin. Large Size - Player 1 Leval A
:p.
:artwork name='mp1lb.bmp' runin. Large Size - Player 1 Level B
:p.
Toggles between level A and B for player 1.
:Note.You will need documention for the specific game to tell you what each difficulty level does.
:h2 res=203.Player 2 Difficulty
:p.
:artwork name='sp2la.bmp' runin. Default Size - Player 2 Level A
:p.
:artwork name='sp2lb.bmp' runin. Default Size - Player 2 Level B
:p.
:artwork name='mp2la.bmp' runin. Large Size - Player 2 Leval A
:p.
:artwork name='mp2lb.bmp' runin. Large Size - Player 2 Level B
:p.
Toggles between level A and B for player 2.
:Note.You will need documention for the specific game to tell you what each difficulty level does.
:h2 res=204.Select
:p.
:artwork name='sslct.bmp' runin. Default Size
:p.
:artwork name='mslct.bmp' runin. Large Size
:p.
Select game level.
:Note.You will need documention for the specific game to tell you what each game level does.
:h2 res=205.Reset
:p.
:artwork name='srst.bmp' runin. Default Size
:p.
:artwork name='mrst.bmp' runin. Large Size
:p.
Reset, or start, the current game
:h2 res=209.Settings
:p.
:artwork name='sdb.bmp' runin. Default Size
:p.
:artwork name='mdb.bmp' runin. Large Size
:p.
Brings up the
:link reftype=hd viewport dependent res=103.
settings dialog
:elink.
for Stella/2.
:h2 res=210.Cartridge Help
:p.
:artwork name='sch.bmp' runin. Default Size
:p.
:artwork name='mch.bmp' runin. Large Size
:p.
Call up online help for current game cartridge.
:note.In order for this to work, you must have the game documentation stored in
the DOCS directory as specified in the
:link reftype=hd viewport dependent res=102.
Online Documentation
:elink.
section.
:h2 res=211.Stella Help
:p.
:artwork name='ssh.bmp' runin. Default Size
:p.
:artwork name='msh.bmp' runin. Large Size
:p.
Calls up the documentation which you are currently reading.
.*
.**********************************************************
.*
:h1 res=103.Settings Dialog
:p.
:artwork align=center name='dialog.bmp'.
:artlink.
:link reftype=hd viewport dependent res=312 x=238 y=42 cx=215 cy=153.
:link reftype=hd viewport dependent res=311 x=5 y=42 cx=230 cy=153.
:link reftype=hd viewport dependent res=310 x=5 y=210 cx=449 cy=113.
:eartlink.
:p.
The settings dialog lets you control various aspects of Stella/2.  This display
shows the default settings for the parameters.  The settings are saved when
you exit Stella/2 in the file :hp4.STELLA.INI:ehp4..  Select any area for more information.
:p.
The :hp4.OK:ehp4. button
will save the changes, :hp4.Cancel:ehp4. will ignore the changes (except for joystick
recalibration), and :hp4.Help:ehp4. will bring you to this section of the help file.
:h2 res=310.Controls
:artwork name='controls.bmp' runin.
:p.
:hp4.Default:ehp4. will set the Paddles to their default assignment
:p.
:hp4.Recalibrate:ehp4. will reset the joystick calibration information.
Once back in Stella/2 the joystick will need to be moved to all 4 corners to complete
the recalibration process.
:p.
:hp4.Paddle 1:ehp4., :hp4.Paddle 2:ehp4., :hp4.Paddle 3:ehp4., :hp4.Paddle 4:ehp4.
are used to select which PC device is used to emulate the paddle control.  :hp4.Real:ehp4.
means you've built the
:link reftype=hd viewport dependent res=400.
Real Paddle Adaptor
:elink.
and have paddles plugged in.  You'll need to recalibrate whenever changing between
PC joysticks and Real Paddles.

:h2 res=311.Audio Settings
:artwork name='audio.bmp' runin.
:p.
:hp4.Enabled:ehp4. controls if sound is on or off.
:p.
:hp4.Oscilloscope:ehp4. controls if the Oscilloscope is displayed.
:p.
:hp4.Buffer Size:ehp4. sets the size of the audio buffer.  If it's set too small
there will be noticable distortion in the sound.  If it's too large then rapidly
changing sound effects may not be heard.
:p.
:hp4.Frequency:ehp4. controls the playback frequency used by Stella/2. 31400 is the
frequency of the Atari's real sound chip.
:p.
:hp4.Default:ehp4. returns audio settings to their default values.
:h2 res=312.Video Settings
:artwork name='video.bmp' runin.
:p.
:hp4.Frames Per Second:ehp4. sets the inital frame rate as well as the minimum and maximum
frame rates that Stella/2 will be allowed to shoot for.  It may take a few seconds for
the emulation to settle out after changing these settings.
:p.
:hp4.Init Size:ehp4. allows you to select the initial size of Stella's window.
:p.
:hp4.Use Cart Height:ehp4. use cartridge height from the properties file.  The default height
of 210 is used when this option is unchecked.
:p.
:hp4.Show Cart Note:ehp4. causes the cartridge note from the properties file to scroll
across the status line.
.*
.**********************************************************
.*
:h1 res=102.Online Game Documentation
:p.
Support for online documention is part of the OS/2 version of Stella.  For this
feature to function, there must be a text doc file for the game located in the DOCS
subdirectory of the STELLA directory.  If the file is not present a warning dialog
will appear.

:p.
You may try this feature out with the included games ELK and OKIEDOKE as the documentation files for both are included with Stella.
:p.
The filename must be the same as the cartridge filename
loaded (the .BIN), with a .DOC extension replacing the .BIN extension.
Doc files are currently displayed using the 'E' editor in OS/2.
They are best viewed using a non-proportional font such as SYSTEM VIO, SYSTEM
MONOSPACED, or COURIER.  Proportional fonts will cause game number matrixes to
be difficult to read. The directory structure is as follows:
:xmp.
&dot.&dot.&dot.(path)&dot.&dot.&dot.\STELLA\DOCS\ELK.DOC
                   |    |OKIEDOKE.DOC
                   |    |Berzerk.doc *
                   |    |Rabbit Transit.doc *
                   |    |Space Invaders.doc *
                   |     etc.
                   |
                   \ROMS\ELK.BIN
                   |    |OKIEDOKE.BIN
                   |    |Berzerk.bin *
                   |    |Rabbit Transit.bin *
                   |    |Space Invaders.bin *
                   |     etc.
                   |
                   |stella.exe
                   |stella.inf
                   |stella.vcs
                   |etc.
:exmp.

* denotes user installed files
.*
.**********************************************************
.*
:h1.Frame Rate Routines
:p.
The frame rate routines work by establishing a target frame rate, dependent
upon the performance of your hardware.  Your CPU speed, Video Hardware performance, and the use
of sound support all directly effect the performance of Stella.
:p.
Instead of the traditional show 1 skip n,
the routines in the OS/2 version of Stella are :hp1.how many frames to skip out of 16.:ehp1.
This gives a more even spread in the target frame rates.  For instance, under the traditional method
the target frame rates are 60, 30, 20, 15, 12, 10, 9, 8, 7, and 6fps.  The
new target frame rates are 60, 56, 53, 49, 45, 41, 38, 34, 30, 26, 23, 19, 15,
11, 8, and 4fps.  The better spread of rates helps performance on faster machines.
:p.
:note.If the emulation achieves its target frame rate, even if it's not 60fps, then
Stella is running at 100% the speed of a real Atari VCS.
.*
.**********************************************************
.*
:h1 res=101.Status Bar
:p.
The status bar shows information about the current game.
:p.
For example, if the following is shown:
:xmp.
29fps 30t 4m 98% 320 x 200
:exmp.
Then Stella is currently achieving 29 frames per second, with a target of 30 fps,
a minimum target rate of
4fps, running at 98% the speed of a real Atari VCS, with a window resolution
of 320 x 200.
:p.
On faster systems, the throttle routines will kick in to slow the
emulation down to the proper speed.  If the throttle routines
are active, the status bar text will change slightly.
The text line will show current frame rate, throttle value, % speed of a real
Atari, and window resolution.
:p.
Throttle active example:
:xmp.
60fps 2T 100% 320 x 190
:exmp.
This shows that Stella is currently achieving 60 frames per second, with a
throttle rate of 2, running at
100% the speed of a real Atari VCS, with a window resolution of 320 x 190.
:p.The left and right sides of the status bar contain icons to signify which Game Controller
is considered plugged into the left and right ports.
:p.
:artwork name='joystick.bmp' runin. Joystick
:p.
:artwork name='Paddles.bmp' runin. Paddles
:p.
:artwork name='Booster-Grip.bmp' runin. Booster Grip (adds extra fire button to joystick)
:p.
:artwork name='Driving.bmp' runin. Driving
:p.
:artwork name='keyboard.bmp' runin. Keypad
:p.
:artwork name='Lightgun.bmp' runin. Lightgun (not currently supported)
:p.
:artwork name='MindLink.bmp' runin. MindLink (not currently supported)

.*
.**********************************************************
.*
:h1.Controllers
:p.
Since you cannot directly plug Atari style controllers(unless you've built the
:link reftype=hd viewport dependent res=400.
Real Paddle Adaptor
:elink.
) into a PC, different ways of obtaining values for the Joystick and Paddle controllers
are implemented in Stella.
:p.
PC style joysticks can emulate both Atari Joysticks and Paddles.
:p.
The PC mouse can emulate one(or more) of the Atari Paddles.
:p.
The keyboard can emulate the Atari Joysticks, as well as provide
control of Stella.
:p.
Real Atari paddles can be used if you've built the
:link reftype=hd viewport dependent res=400.
Real Paddle Adaptor
:elink.

.*
.**********************************************************
.*
:h2.Joysticks
:p.
Joystick support requires the joystick divers to be loaded.  If your system
does not already have the drivers installed, unzip the joystick.zip archive
included with Stella, and run install.cmd.  Your system will need to be rebooted
after installing the drivers for them to work.
:p.
The joysticks will calibrate themselves as the games are played.  Stella
uses the SpiceWare Joystick Routines(available on the SpiceWare homepage at
:hp4.http&colon.//home.houston.rr.com/spiceware:ehp4.
for those OS/2 programmers
out there!), and will save the calibration information
so it can be reloaded. Both
firebuttons are mapped to the single firebutton of the Atari joystick(unless the
controller is the Booster Grip).
:p.
The
:link reftype=hd viewport dependent res=310.
Settings Dialog
:elink.
allow the joysticks to be mapped as game paddles.  This
is not recommended to be used with the game pad (Sega Genesis style) controllers,
as they would only return three discrete paddle positions. Flight sticks, and old-style PC
joysticks work best for paddle emulation.  When used as a paddle, both firebuttons
are mapped to the paddle's fire button.
:note.By using the keyboard controls, Stella can be used without joysticks.
.*
.**********************************************************
.*
:h2.Mouse
:p.
By default, the mouse is used to emulate paddle 0.
:p.
Whenever a paddle based game is run, Stella will capture
the mouse pointer.  If the mouse pointer is captured, then hold
down :hp4.CONTROL:ehp4. to release it to be able to
select menu options.
.*
.**********************************************************
.*
:h2 res=401.Keyboard
:p.
The keyboard is mapped to emulate the switches and controllers of the Atari.
:xmp.
F1      Select Game Level
F2      Reset/Start Game
F3      Color
F4      Black &amp. White

F5      Player 1 Level A
F6      Player 1 Level B
F7      Player 2 Level A
F8      Player 2 Level B

PAUSE   Pause/Unpause Game
ESC     Quit Game
INSERT  Load New Cartridge


CNTL-1  Set Screen To 320 x 210 (or 320 x game height depending on settings.)
CNTL-2 thru CNTL-9 - multiply the base window size by the number pressed
(the window may also be scaled to any size by grabbing &amp. moving the window borders)


JOYSTICKS&colon.
Cursor Pad - Player 1's Joystick
R-ALT   Player 1's Fire Button(Thrust for Omega Race)
R-CTRL  Player 1's Fire (Omega Race only)

F       Player 2's Joystick UP
C       Player 2's Joystick Left
V       Player 2's Joystick Down
B       Player 2's Joystick Right
L-SHIFT Player 2's Fire Button (Thrust for Omega Race)
L-CTRL  Player 2's Fire (Omega Race only)


DRIVING&colon.
Cursor Pad - Player 1's Left/Right
R-ALT   Player 1's Gas Pedal

C       Player 2's Left
B       Player 2's Right
L-SHIFT Player 2's Gas Pedal


KEYPAD&colon.
1 2 3   Keypad 1
Q W E
A S D
Z X C

7 8 9   Keypad 2
U I O
J K L
M , .
:exmp.
:h2 res=400.Real Paddle Adaptor
:p.Stella supports real Atari 2600 paddles using a special adaptor which
connects to the PC game port. The adaptor requires the following parts:
:xmp.
 1 DB15 male connector (joystick extension cable plugs into this)
 2 DB9 male connectors (paddles plug into these)
 4 115k resistors
 1 Small project box
 1 Joystick extension cable
 Some wire or ribbon cable
:exmp.
:p.Most of these parts can be found at Radio Shack. If you cannot find a DB15
connector  you could sacrifice a joystick extension cable.  Also a 100k resistor
and 15k resistor can be placed in series to make a 115k resistor. A schematic of
the adaptor is shown below:
:p.
:artwork name='real-paddles.bmp' runin.
:note.As you build the adaptor be careful not to short the +5V and GND connections.
:hp8.:warning.
USE IT AT YOUR OWN RISK!
:ewarning.:ehp8.
.*
.**********************************************************
.*
:h1 res=402.Keyboard Remapping
:p.
The keys used to control Stella/2 can be remapped.
However, remapping of the keys is not yet integrated
within Stella/2.  Two utility programs, located in the :hp4.KEYMAP:ehp4.
directory, are included to help with the changing of keyboard controls.
:h2.Utility Programs
:p.
The first program, :hp4.SCANCODE:ehp4., is based on sample
code from Charles Petzold's book, :hp4.OS/2 Presentation Manager Programming:ehp4..
This program is used to find the hex value for each key on the keyboard.
:p.
The second program, :hp4.INIEDIT:ehp4., is used to edit the scancode entries in Stella's INI file.
It is available from IBM's Employee Written Software site at
:hp4.ftp&colon.//ftp.pc.ibm.com/pub/pccbbs/os2_ews/:ehp4.

:h2.Example Remapping
:p.In this example, the fire key for the left controller
will be changed from the Right ALT key to the Space Bar.
:note.If something goes wrong, just delete the file :hp4.STELLA.INI:ehp4.
and it will be recreated with all the defaults the next time Stella/2 is run.
:ol.
:li.Run SCANCODE to find the hex values of the keys involved.
:artwork name='scancode.bmp'.
:li.Run INIEDIT and open the file :hp4.STELLA.INI:ehp4.
:artwork name='iniedit1.bmp'.
:li.Select the application :hp4.keyboard:ehp4. from the list.
:artwork name='iniedit2.bmp'.
:li.Select the key :hp4.JoystickZeroFire:ehp4. from the list
:artwork name='iniedit3.bmp'.
:li.After confirming the Hex value was correct(5E for the right ALT key), change
it to the new value(39 for the Space Bar).
:artwork name='iniedit4.bmp'.
:eol.
:h2.Key values in STELLA.INI
:table cols='22 50'.
:row.
:c.NewGame
:c.Select New Game Cartridge
:row.
:c.Pause
:c.Pause Emulation
:row.
:c.Quit
:c.Quit Emulation
:row.
:c.Select
:c.Select Game Level
:row.
:c.Reset
:c.Reset/Start Game
:row.
:c.Color
:c.Select Color TV Mode
:row.
:c.BnW
:c.Select Black and White TV Mode
:row.
:c.1A
:c.Set Left Player to Difficulty Setting A
:row.
:c.1B
:c.Set Left Player to Difficulty Setting B
:row.
:c.2A
:c.Set Right Player to Difficulty Setting A
:row.
:c.2B
:c.Set Right Player to Difficulty Setting B
:row.
:c.JoystickZeroLeft
:c.Left Player's Joystick
:row.
:c.JoystickZeroRight
:c.Left Player's Joystick
:row.
:c.JoystickZeroUp
:c.Left Player's Joystick
:row.
:c.JoystickZeroDown
:c.Left Player's Joystick
:row.
:c.JoystickZeroFire
:c.Left Player's Joystick
:row.
:c.BoosterGripZeroTrigger
:c.Left Player's Joystick - Extra Fire Button(used by Omega Race)
:row.
:c.JoystickOneLeft
:c.Right Player's Joystick
:row.
:c.JoystickOneRight
:c.Right Player's Joystick
:row.
:c.JoystickOneUp
:c.Right Player's Joystick
:row.
:c.JoystickOneDown
:c.Right Player's Joystick
:row.
:c.JoystickOneFire
:c.Right Player's Joystick
:row.
:c.BoosterGripOneTrigger
:c.Right Player's Joystick - Extra Fire Button(used by Omega Race)
:row.
:c.KeyboardZero1
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero2
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero3
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero4
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero5
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero6
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero7
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero8
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero9
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZeroStar
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZero
:c.Left Player's Keypad Controller
:row.
:c.KeyboardZeroPound
:c.Left Player's Keypad Controller
:row.
:c.KeyboardOne1
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne2
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne3
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne4
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne5
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne6
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne7
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne8
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne9
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOneStar
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOne0
:c.Right Player's Keypad Controller
:row.
:c.KeyboardOnePound
:c.Right Player's Keypad Controller
:etable.
.*
.**********************************************************
.*
:h1.Acknowledgements
:p.
The following is an incomplete list of the people who have played a part in bringing Stella to you
:table cols='20 50'.
:row.
:c.Marty Amodeo
:c.For help with trapping the ALT key(otherwise the Menu Bar get activated) and with
stealing the mouse pointer for better Paddle Emulation. Marty is the porter of the
OS/2 versions of MAME, Retrocade and SNES9x.
:row.
:c.David Asbell
:c.Ported release 0.7 of Stella to Java
:row.
:c.Christopher Bennett
:c.Helped discover a Superchanger emulation bug in release 1.0 of Stella
:row.
:c.Alexander Bilstein
:c.Provided "A Brief History of the Atari 2600" for this manual
:row.
:c.Dan Boris
:c.Provided technical information on the Supercharger
:row.
:c.Piero Cavina
:c.Allowed "Oystron" to be included in the Stella distribution
:row.
:c.Bob Colbert
:c.Allowed "Okie Dokie" to be included in the Stella distribution (rcolbert@novia.net)
:row.
:c.Joe D'Andrea
:c.Author of the IRIX port of Stella
:row.
:c.Renato Ferreira
:c.Provided code to support private colormaps under Unix
:row.
:c.Ron Fries
:c.Author of the TiaSound library
:row.
:c.Aaron Giles
:c.Maintained the Power Mac version
:row.
:c.Mark R. Hahn
:c.Allowed "Elk Attack" to be included in the Stella distribution and provided help with the TIA HMOVE blank bug
:row.
:c.Kevin Horton
:c.Author of the 2600 bankswitching method paper
:row.
:c.Erik Kovach
:c.Author of the property file for release 0.7, 1.0, and 1.1 of Stella
:row.
:c.Thomas A. K. Kjaer
:c.Provided code to implement OS/2's drag and drop support.
:row.
:c.Daniel Marks
:c.Provided code to improve the keyboard joystick support
:row.
:c.David McEwen
:c.Author of the Acorn version of Stella
:row.
:c.Jeff Miller
:c.Maintained the Windows version

:row.
:c.Bradford Mott
:c.Maintained the core code, Linux SVGA version and X version
:row.
:c.Jack Nutting
:c.Author of the OpenStep version of Stella
:row.
:c.Jim Pragit
:c.Author of the "Game Menu" emulator game shell
:row.
:c.John Saeger
:c.Participated in a helpful discussion on understanding the TIA s RESPx multi-sprite trick
:row.
:c.Chris Salomon
:c.Provided information and code to implement Supercharger support
:row.
:c.Jason Scott
:c.Organizer of the property file archive for early versions of Stella; now he's
helping with the web site
:row.
:c.David Shaw
:c.Provided make targets for the BSDI platform
:row.
:c.Raul Silva
:c.Helped with the the design and graphics on the home page
:row.
:c.Chris Snell
:c.Maintained a mirror of the Stella FTP site
:row.
:c.Darrell Spice, Jr.
:c.Author of the OS/2 version of Stella
:row.
:c.Eckhard Stolberg
:c.Provided a description of the TIA bug that produces the star field effect in
Cosmic Ark, provided the PAL television palette, and participated in a
helpful discussion on understanding the TIA s RESPx multi-sprite trick
:row.
:c.Matthew Stroup
:c.Author of the Amiga version of Stella
:row.
:c.Joel Sutton
:c.Author of the FreeBSD version of Stella
:row.
:c.Greg Troutman
:c.Allowed "This Planet Sucks" to be included in the Stella distribution
:row.
:c.Keith Wilkins
:c.Maintained the MS-DOS version until ver 0.7
:row.
:c.Jeff Wisnia
:c.Provided technical data sheet for the 6532 RIOT chip
:row.
:c.Dan Mowczan
:c.Provided a Supercharger to help with Stella's development
:row.
:c.Countless others
:c.Many of the features present in Stella are a result of input from people who have sent in suggestions

:etable.
:p.
Thanks to all the 2600 fans who've kept encouraging us to continue.
.*
.**********************************************************
.*
:h1.Stella/2 Version History
:p.
:ul.
:li.:hp4.Version 1.1 released November 3, 2000:ehp4.
:ol.
:LI.Migrated OS/2 source to current core release
:ol compact.
:li.support real Atari 2600 paddles using a special
:link reftype=hd viewport dependent res=400.
Real Paddle Adaptor
:elink.
:li.Greatly improved Supercharger single-load and multi-load game support
:li.Improved TIA emulation to support the RESPx multi-sprite trick
:li.Improved timer emulation (6532 PIA)
:li.Improved CPU emulation (6502)
:li.Supports Robot Tank and Decathlon
:li.Supports Joystick, Keyboard, Booster Grip, and Indy 500 Driving controllers
:li.Preliminary support for Chris Wilkson's Megacart bank-switching scheme
:li.Contains properties for over 1300 ROMs
:li.Optimizations to improve speed
:li.And much more...
:eol.
:li.improved throttle routines for faster systems
:li.added PAL color palette and frame rates
:li.new game controller status (which controller needed for current cartridge)
:li.settings dialogs
:li.keyboard controls are now
:link reftype=hd viewport dependent res=402.
user definable
:elink.
:li.
:link reftype=hd viewport dependent res=401.
Keyboard
:elink.
controls have changed
:li.And much more...
:eol.
:li.:hp4.Version 0.7 released June 8, 1997:ehp4.
:ol.
:li.Throttle routines added (many games are going over 60fps on my system)
:li.Oscilliscope added.
:li.Display.Height property now supported.  Window may now be taller or shorter than 200 pixels.
:li.Stella now uses the SpiceWare joystick routines - no need to recalibrate each time you run Stella.
:li.The game backgammon now works.  Previously, the paddle support would not allow you to select all of the gameboard positions.
:li.Stella Help is now in the OS/2 standard format.
:li.Stella Help and Cartridge help now work correctly if there are spaces in the file path.
:li.Migrated OS/2 source to new 0.7 core.
:ol compact.
:li.Improved emulation speed of TIA and 6507
:li.Added Starpath Supercharger support
:li.Added Tigervision bankswitching support (3F bankswitching)
:li.VCS files combined into a single builtin property file
:li.Added TIA HMOVE "feature" to support Cosmic Ark stars
:li.Improved TIA VSYNC code so that it works more like the real thing (0.6 VSYNC code caused the graphics of some games to be off such as Alien and Battle Zone)
:li.Added two 6507 emulators: one is designed to act more like the real thing, while the other is designed to be as fast as possible (required for Supercharger support)
:li.Changed TIA peeking so lower nibble of byte read is the same as the TIA address being accessed (Warlords now works)
:eol.
:eol.
:li.:hp4.Version 0.61 released February 9, 1997:ehp4.
:ol.
:li.Added a cartridge ID routine which calculates a unique ID for each cartridge.
This is used by Stella to know which games use paddles or joysticks, without
needing a *.VCS file.  If you find a game that still needs the *.VCS file to
work, send me e-mail w/the cartridge ID and settings needed.
:li.Improved Drag and Drop by making sure window becomes active after a drop.
:li.Fixed three problems that occured if a Stella was started by dragging a game onto it.
:ol compact.
:li.Cartridge help is now available for the first game.
:li.Other games can now be loaded, Stella no longer refuses to load other games.
:li.The Stella Help file can now be found and displayed.
:eol.
:li.Fixed the "Cannot write to GAME$ drive" error message when Cartridge Help or Stella Help is called up.
:eol.
:li.:hp4.Version 0.6 released January 19, 1997:ehp4.
:ol.
:li.Added joystick support. New parameters allow mapping of a joystick to any of the 4 paddle readings.
:li.Added new program parameters for frequency selection for soundcards unable to support 31.4 KHz
:li.Improved sound routine calls to TiaSound to eliminate the repeating click that sometimes occured in ver 0.53.
:li.Added larger, more detailed menu buttons for a 640x400 window.
:li.Fixed problem with a paused game not always wanting to unpause.
:li.Added Drag and Drop support for *.BIN and *.VCS files. Thanks goes to Thomas A. K. Kjaer for providing sample source from his OS/2 port of X128, the ZX Spectrum Sinclair emulator.  Visit his site at: www.daimi.aau.dk/~takjaer/x128-OS2/x128.html
:li.Migrated OS/2 source to new 0.6 core.
:ol compact.
:li.Fixed collision detection problem (Freeway works)
:li.Changed PIA timing code to fix screen jitters
:li.Added new bank switching methods: F4SC (Fatal Run), E7 (Burgertime)
:li.Fixed some code in the TIA emulation that caused SEGFAULTS
:eol.
:li.Improved frame rate throttling code to work better on fast machines
:li.Improved TIA emulation (missle graphics are fully emulated now)
:li.Included Bob Colbert's "Okie Dokie" game
:li.Included new TiaSound ver 1.1 routines which improves sound output during rapidly changing sound effects.
:eol.
:li.:hp4.Version 0.53 released December 21, 1996:ehp4.
:ol.
:li.Added sound support.
:li.Fixed problem with core Stella errors not showing up for any game after the first cartridge is successfully loaded.
:eol.
:li.:hp4.Version 0.52 released December 15, 1996:ehp4.
:ol.
:li.Added support to show the core Stella errors.  These errors would cause the prior OS/2 version of Stella, if an error occured, to abort withhout displaying any error message.
:li.Fix bug in frame rate calculation which caused fps to be overstated(ie: if it said 30fps, you actually were getting 27fps).
:li.Revised frame rate routine to calculate fps once per second instead of every
frame.  This caused an increase in the frame rate(even after fixing the frame
rate calc bug).  For me, games that acheived 30fps (really 27fps) on ver 0.5.1
are now getting 45fps on ver 0.52!  I guess accessing the clock used up a lot
of CPU time.
:li.Revised frame skipping method so that games needing to flicker (such as the
missles in Space Invaders, Pac Man ghosts, Match in Haunted House, ect) will
show objects that only appear every other frame.  Pac Man is based on every
4th frame (that's why the ghosts flicker so badly on the original Atari), so
you need to achieve at least 15 fps on Pac Man to see all 4 ghosts.
:eol.
:li.:hp4.Version 0.5.1 released December 3, 1996:ehp4.
:ol.
:li.DIVE support! doubles the frame rate
:li.Added temporary online help facility
:li.Added support for online cartridge documentation
:li.Added graphic menu bar
:li.Revised frame rate skipping routines for smoother target framerate
:li.changed keyboard mapping
:eol.
:li.:hp4.Version 0.5 released November 15, 1996:ehp4.
:ol.
:li.Migrated OS/2 source to new 0.5 core(much faster!  Berzerk used to have to
skip 13 frames to achieve 100%, now it only has to skip 3 or 4[on a 256 color
screen])
:li.Fixed File Dialog(cartridge selection) to not reset the directory
:eol.
:li.:hp4.Version 0.4.1 released September 29, 1996:ehp4.
:ol.
:li.Figured out how to correctly activate VAC++ code optimization(not only do you
select the optimization options in OPTIONS/COMPILE, you must also select
Optimizer in OPTIONS/BUILD SMARTS)  &colon.-)  This improves performance an average
of 50%.
:li.Added automatic frame skipping (w/max skip).
:li.Added manual run-time frame skipping.
:eol.
:li.:hp4.version 0.4 released September 15, 1996:ehp4.
:ol.
:li.initial release for OS/2
:eol.
:eul.
.*
.**********************************************************
.*
.*:h1.Stella/2 To Do list
.*:p.
.*The To Do's are not listed in any order.
.*:ol.
.*:li.Add support for Full Screen DIVE
.*:eol.
:euserdoc.
